Funk_data_CA = attributes Funk_data
attribID:#(0xaf709ca, 0x64ff0330)
(
	parameters Funk rollout:funk_params
	(
		funk_distance_param ui:funk_distance type:#integer default:1
		funk_animation_param ui:funk_animation type:#integer default:1
		funk_animation_mode_param ui:funk_animation_mode type:#integer default:1
		funk_animation_speed_x ui:funk_animation_speed_x type:#float default:1
		funk_animation_speed_y ui:funk_animation_speed_y type:#float default:1
		funk_animation_extent_x ui:funk_animation_extent_x type:#float default:1
		funk_animation_extent_y ui:funk_animation_extent_y type:#float default:1
		funk_animation_centre_x ui:funk_animation_centre_x type:#float default:0.5
		funk_animation_centre_y ui:funk_animation_centre_y type:#float default:0.5
		funk_sequence_param ui:funk_sequence type:#integer default:1
		funk_playback_param ui:funk_playback type:#integer default:1
		funk_sequence_type_param ui:funk_sequence_type type:#integer default:1
		funk_sequence_frame_names_param ui:funk_sequence_frame_names type:#string default:"Place your Texture names here\r\nseperated by enter"
		
	)
	rollout Funk_params "CARMATOOLS - FUNK properties"
	(
		group "General"
		(
		label funk_distance_label "Distance:" align:#right across:2 offset:[-10,3]
		dropdownlist funk_distance "" items:#("DISTANT", "CONSTANT","LASTLAP","OTHERLAPS") selection:1 align:#right label:false tooltip:"Only move when Distant, or always move."
		)
		group "Amimation"
		(
			label funk_animation_label "Type:" align:#right across:2 offset:[-10,3]
			dropdownlist funk_animation "" items:#("PISS OFF", "ROLL", "SLITHER", "THROB") selection:1 align:#right label:false tooltip:"Change the animation of the texture."
			label funk_animation_mode_label "Mode:" align:#right across:2 offset:[-10,3] enabled:(funk_animation_param != 1)
			dropdownlist funk_animation_mode "" items:#("HARMONIC", "LINEAR", "CONTINUOUS") selection:1 align:#right label:false tooltip:"Change the mode of the animation." enabled:(funk_animation_param != 1)
			label funk_animation_speed_label "Speed X,Y:" align:#right enabled:(funk_animation_param != 1) tooltip:"Speed of the animation, in x and y direction." across:3
			spinner funk_animation_speed_x "" type:#float range:[-999999,999999,1] scale: 0.1 fieldWidth:65 align:#right enabled:(funk_animation_param != 1)
			spinner funk_animation_speed_y "" type:#float range:[-999999,999999,1] scale: 0.1 fieldWidth:65 align:#right enabled:(funk_animation_param != 1)
			label funk_animation_extent_label "Distance X,Y:" align:#right enabled:(funk_animation_param == 3 or funk_animation_param == 4) tooltip:"Extent of the animation, in x and y direction." across:3
			spinner funk_animation_extent_x "" type:#float range:[-999999,999999,1] scale: 0.1 fieldWidth:65 align:#right  enabled:(funk_animation_param == 3 or funk_animation_param == 4)
			spinner funk_animation_extent_y "" type:#float range:[-999999,999999,1] scale: 0.1 fieldWidth:65 align:#right  enabled:(funk_animation_param == 3 or funk_animation_param == 4)
			label funk_animation_centre_label "Centre X,Y:" align:#right enabled:(funk_animation_param == 4) tooltip:"Centre of the animation, in x and y direction" across:3
			spinner funk_animation_centre_x "" type:#float range:[-999999,999999,0.5] scale: 0.1 fieldWidth:65 align:#right enabled:(funk_animation_param == 4)
			spinner funk_animation_centre_y "" type:#float range:[-999999,999999,0.5] scale: 0.1 fieldWidth:65 align:#right enabled:(funk_animation_param == 4)
		)
		group "Lighting:"
		(
		label funk_lighting_label "Lighting:" align:#right across:2 offset:[-10,3]
		dropdownlist funk_lighting "" items:#("NO LIGHTING") selection:1 align:#right label:false tooltip:"Placeholder for eventual lighting settings"
		)
			group "Sequence"
		(
			label funk_sequence_label "Sequence:" align:#right across:2 offset:[-10,3]
			dropdownlist funk_sequence "" items:#("NONE","FRAMES") selection:1 align:#right label:false tooltip:"Change the animation of the texture."
			label funk_sequence_playback_label "Playback:" align:#right across:2 offset:[-10,3] enabled:(funk_sequence_param != 1)
			dropdownlist funk_playback "" items:#("APPROXIMATE","ACCURATE") selection:1 align:#right label:false tooltip:"Change the playback type of the Sequence." enabled:(funk_sequence_param != 1)
			label funk_sequence_type_label "Type:" align:#right across:2 offset:[-10,3] enabled:(funk_sequence_param != 1)
			dropdownlist funk_sequence_type "" items:#("CONTINUOUS","LINEAR","HARMONIC","FLASH") selection:1 align:#right label:false tooltip:"Change the playback type of the Sequence." enabled:(funk_sequence_param != 1)
			spinner funk_sequence_framerate "Framerate: " type:#float range:[0,999999,0.5] scale: 0.1 fieldWidth:72 align:#Right  enabled:(funk_sequence_param != 1)
			dotNetControl funk_sequence_frame_names "Textbox" height:72 width:155 align:#right label:"Names:" enabled:(funk_sequence_param != 1)
			on Funk_params open do
			(
				funk_sequence_frame_names.MultiLine = true
				funk_sequence_frame_names.WordWrap = true
				funk_sequence_frame_names.BackColor = (dotNetClass "System.Drawing.Color").fromARGB (((colorMan.getColor #background) * 255)[1] as integer) (((colorMan.getColor #background) * 255)[2] as integer) (((colorMan.getColor #background) * 255)[3] as integer)
				funk_sequence_frame_names.ForeColor = (dotNetClass "System.Drawing.Color").fromARGB (((colorMan.getColor #text) * 255)[1] as integer) (((colorMan.getColor #text) * 255)[2] as integer) (((colorMan.getColor #text) * 255)[3] as integer)
				funk_sequence_frame_names.ScrollBars = (dotNetClass "System.Windows.Forms.ScrollBars").Vertical
				funk_sequence_frame_names.AcceptsReturn = true
				funk_sequence_frame_names.AcceptsTab = true
				funk_sequence_frame_names.enabled = true
				funk_sequence_frame_names.text = funk_sequence_frame_names_param
			)
			on funk_sequence_frame_names keydown pressedKey do 
			(
				if (pressedKey.keyvalue == 13) do 
				(
					funk_sequence_frame_names.paste("\r\n")
					funk_sequence_frame_names_param  = funk_sequence_frame_names.Text
				)

			)
			on funk_sequence selected i do 
			(
				if i == 1 then
				(
					funk_sequence_playback_label.enabled = false
					funk_playback.enabled = false
					funk_sequence_type_label.enabled = false
					funk_sequence_type.enabled = false
					funk_sequence_framerate.enabled = false
					funk_sequence_frame_names.enabled = false
					funk_sequence_frame_names.BackColor = (dotNetClass "System.Drawing.Color").fromARGB (((colorMan.getColor #background) * 255)[1] as integer) (((colorMan.getColor #background) * 255)[2] as integer) (((colorMan.getColor #background) * 255)[3] as integer)
				)
				if i == 2 then
				(
					funk_sequence_playback_label.enabled = true
					funk_playback.enabled = true
					funk_sequence_type_label.enabled = true
					funk_sequence_type.enabled = true
					funk_sequence_framerate.enabled = true
					funk_sequence_frame_names.enabled = true
					funk_sequence_frame_names.BackColor = (dotNetClass "System.Drawing.Color").fromARGB (((colorMan.getColor #window) * 255)[1] as integer) (((colorMan.getColor #window) * 255)[2] as integer) (((colorMan.getColor #window) * 255)[3] as integer)
				)
			)
		)
		on funk_animation selected i do 
		(
			if i == 1 then
			(
				funk_animation_mode_label.enabled = false
				funk_animation_mode.enabled = false
				funk_animation_speed_label.enabled = false
				funk_animation_speed_x.enabled = false
				funk_animation_speed_y.enabled = false
				funk_animation_extent_label.enabled = false
				funk_animation_extent_x.enabled = false
				funk_animation_extent_y.enabled = false
				funk_animation_centre_label.enabled = false
				funk_animation_centre_x.enabled = false
				funk_animation_centre_y.enabled = false
			)
			if i == 2 then
			(
				funk_animation_mode_label.enabled = true
				funk_animation_mode.enabled = true
				funk_animation_speed_label.enabled = true
				funk_animation_speed_x.enabled = true
				funk_animation_speed_y.enabled = true
				funk_animation_extent_label.enabled = false
				funk_animation_extent_x.enabled = false
				funk_animation_extent_y.enabled = false
				funk_animation_centre_label.enabled = false
				funk_animation_centre_x.enabled = false
				funk_animation_centre_y.enabled = false
			)
			if i == 3 then
			(
				funk_animation_mode_label.enabled = true
				funk_animation_mode.enabled = true
				funk_animation_speed_label.enabled = true
				funk_animation_speed_x.enabled = true
				funk_animation_speed_y.enabled = true
				funk_animation_extent_label.enabled = true
				funk_animation_extent_x.enabled = true
				funk_animation_extent_y.enabled = true
				funk_animation_centre_label.enabled = false
				funk_animation_centre_x.enabled = false
				funk_animation_centre_y.enabled = false
			)
			if i == 4 then
			(
				funk_animation_mode_label.enabled = true
				funk_animation_mode.enabled = true
				funk_animation_speed_label.enabled = true
				funk_animation_speed_x.enabled = true
				funk_animation_speed_y.enabled = true
				funk_animation_extent_label.enabled = true
				funk_animation_extent_x.enabled = true
				funk_animation_extent_y.enabled = true
				funk_animation_centre_label.enabled = true
				funk_animation_centre_x.enabled = true
				funk_animation_centre_y.enabled = true
			)
		)
		
	)
)
