Groove_data_CA = attributes Groove_data
attribID:#(0x6464f3cd, 0x76c6fa01)
(
	parameters groove rollout:groove_params
	(
		groove_lollipop_param ui:groove_lollipop type:#integer default:1
		groove_distance_param ui:groove_distance type:#integer default:1
		
		groove_path_type_param ui:groove_path_type type:#integer default:1
		groove_path_mode_param ui:groove_path_mode type:#integer default:1
		groove_path_center_X_param type:#float ui:groove_path_centre_x default:0
		groove_path_center_Y_param type:#float ui:groove_path_centre_y default:0
		groove_path_center_Z_param type:#float ui:groove_path_centre_z default:0
		groove_path_extent_X_param type:#float ui:groove_path_extent_x default:0
		groove_path_extent_Y_param type:#float ui:groove_path_extent_y default:0
		groove_path_extent_Z_param type:#float ui:groove_path_extent_z default:0
		groove_path_speed_param type:#float ui:groove_path_speed default:1
		groove_path_radius_param type:#float ui:groove_path_radius default:0.5
		groove_path_axis_param ui:groove_path_axis type:#integer default:3
		
		groove_animation_type_param ui:groove_animation_type type:#integer default:1
		groove_animation_mode_param ui:groove_animation_mode type:#integer default:1
		groove_animation_speed_param ui:groove_animation_speed type:#float default:1
		groove_animation_centre_x_param type:#float ui:groove_animation_centre_x default:0
		groove_animation_centre_y_param type:#float ui:groove_animation_centre_y default:0
		groove_animation_centre_z_param type:#float ui:groove_animation_centre_z default:0
		groove_animation_axis_param type:#integer ui:groove_animation_axis default:3
		groove_animation_angle_param type:#float ui:groove_animation_angle default:0
		groove_animation_extent_x_param type:#float ui:groove_animation_extent_x default:0
		groove_animation_extent_y_param type:#float ui:groove_animation_extent_y default:0
		groove_animation_extent_z_param type:#float ui:groove_animation_extent_z default:0
	)
	rollout groove_params "Groove Parameters"
	(
		label groove_lollipop_label "Lollipop:" across:2 offset:[0,2]
		dropdownlist groove_lollipop "" items:#("None", "Xlollipop", "Ylollipop", "Zlollipop")
		label groove_distance_label "Distance:" across:2 offset:[0,2]
		dropdownlist groove_distance "" items:#("Distant", "Constant")
		
		group "Path"
		(
			label groove_path_type_label "Type:" across:2 offset:[0,2]
			dropdownlist groove_path_type "" items:#("No Path", "Straight", "Circular")
			label groove_path_mode_label "Mode:" across:2 offset:[0,2] enabled:(groove_path_type_param !=1)
			dropdownlist groove_path_mode "" items:#("Linear", "Harmonic", "Flash","Absolute") enabled:(groove_path_type_param !=1)
			label groove_path_centre_label "Centre X,Y,Z:" tooltip:"Centre of the movement. I guess the actor will use this as a start position." enabled:(groove_path_type_param !=1)
			spinner groove_path_centre_x "" type:#float range:[-999999,999999,0] align:#left width: 40 scale: 0.1 across:3 enabled:(groove_path_type_param !=1)
			spinner groove_path_centre_y "" type:#float range:[-999999,999999,0] align:#center width: 40 scale: 0.1 enabled:(groove_path_type_param !=1)
			spinner groove_path_centre_z "" type:#float range:[-999999,999999,0] align:#right width: 40 scale: 0.1 enabled:(groove_path_type_param !=1)
			label groove_path_extent_label "Extent X,Y,Z:" tooltip:"Extent of the movement. I guess the actor will use this as a start position." enabled:(groove_path_type_param ==2)
			spinner groove_path_extent_x "" type:#float range:[-999999,999999,0] align:#left width: 40 scale: 0.1 across:3 enabled:(groove_path_type_param ==2)
			spinner groove_path_extent_y "" type:#float range:[-999999,999999,0] align:#center width: 40 scale: 0.1 enabled:(groove_path_type_param ==2)
			spinner groove_path_extent_z "" type:#float range:[-999999,999999,0] align:#right width: 40 scale: 0.1 enabled:(groove_path_type_param ==2)
			spinner groove_path_speed "Speed:" type:#float range:[0,999999,0] scale: 0.1 fieldWidth:40 align:#right offset:[0,5] enabled:(groove_path_type_param !=1 and groove_path_mode_param !=4)
			spinner groove_path_radius "Radius:" type:#float range:[0,999999,0] scale: 0.1 fieldWidth:40 align:#right offset:[0,5] enabled:(groove_path_type_param ==3)
			label groove_path_axis_label "Axis:" across:2 offset:[0,2] enabled:(groove_path_type_param ==2 and groove_path_mode_param ==5 and groove_path_mode_param ==6 )
			dropdownlist groove_path_axis "" items:#("X", "Y", "Z") enabled:(groove_path_type_param ==2 and groove_path_mode_param ==5 and groove_path_mode_param ==6 )
			on groove_path_type selected i do
			(
				if i == 1 do
				(
					groove_path_mode_label.enabled = false
					groove_path_mode.enabled = false
					groove_path_centre_label.enabled = false
					groove_path_centre_x.enabled = false
					groove_path_centre_y.enabled = false
					groove_path_centre_z.enabled = false
					groove_path_extent_label.enabled = false
					groove_path_extent_x.enabled = false
					groove_path_extent_y.enabled = false
					groove_path_extent_z.enabled = false
					groove_path_speed.enabled = false
					groove_path_radius.enabled = false
					groove_path_axis.enabled = false
					groove_path_axis_label.enabled = false
				)
				if i == 2 do
				(
					groove_path_mode_label.enabled = true
					groove_path_mode.enabled = true
					groove_path_centre_label.enabled = true
					groove_path_centre_x.enabled = true
					groove_path_centre_y.enabled = true
					groove_path_centre_z.enabled = true
					groove_path_extent_label.enabled = true
					groove_path_extent_x.enabled = true
					groove_path_extent_y.enabled = true
					groove_path_extent_z.enabled = true
					groove_path_speed.enabled = true
					groove_path_radius.enabled = false
					groove_path_axis.enabled = false
					groove_path_axis_label.enabled = false
				)
				if i == 3 do
				(
					groove_path_mode_label.enabled = true
					groove_path_mode.enabled = true
					groove_path_centre_label.enabled = true
					groove_path_centre_x.enabled = true
					groove_path_centre_y.enabled = true
					groove_path_centre_z.enabled = true
					groove_path_extent_label.enabled = false
					groove_path_extent_x.enabled = false
					groove_path_extent_y.enabled = false
					groove_path_extent_z.enabled = false
					groove_path_speed.enabled = false
					groove_path_radius.enabled = true
					groove_path_axis.enabled = true
					groove_path_axis_label.enabled = true
				)
			)
			on groove_path_mode selected i do
			(
				if i==4 then
				(
					groove_path_speed.enabled = false
				)
				else
				(
					groove_path_speed.enabled = true
				)
			)
		)
		group "Animation:"
		(
			label groove_animation_type_label "Type:" across:2 offset:[0,2] 
			dropdownlist groove_animation_type "" items:#("None","Spin","Rock","Shear","Throb") selection:1 width:80 align:#right
			label groove_animation_mode_label "Mode:" across:2 offset:[0,2]  enabled:(groove_animation_type_param !=1)
			dropdownlist groove_animation_mode "" items:#("Linear","Harmonic","Flash","Continuous","Absolute","Controlled") width:80 seleciton:1 align:#right enabled:(groove_animation_type_param !=1)
			spinner groove_animation_speed "Speed: " type:#float range:[-999999,999999,1] scale: 0.1  fieldWidth:40 enabled:(groove_animation_type_param !=1 and groove_animation_mode_param !=6 and groove_animation_mode_param !=5)
			label groove_animation_centre "Centre of Movement:" offset:[0,2] enabled:(groove_animation_type_param !=1)
			spinner groove_animation_centre_x "" type:#float range:[-999999,999999,0] scale: 0.1 fieldWidth:40 align:#left across:3 enabled:(groove_animation_type_param !=1)
			spinner groove_animation_centre_y "" type:#float range:[-999999,999999,0] scale: 0.1 fieldWidth:40 align:#center enabled:(groove_animation_type_param !=1)
			spinner groove_animation_centre_z "" type:#float range:[-999999,999999,0] scale: 0.1 fieldWidth:40 align:#right enabled:(groove_animation_type_param !=1)
			label groove_animation_axis_label "Axis:" across:2 offset:[0,2] enabled:(groove_animation_type_param ==2) enabled:(groove_animation_type_param ==3)
			dropdownlist groove_animation_axis "" items:#("X","Y","Z") seleciton:1 width:80  align:#right enabled:(groove_animation_type_param ==2) enabled:(groove_animation_type_param ==3) enabled:(groove_animation_mode_param==5) enabled:(groove_animation_mode_param==6)
			spinner groove_animation_angle "Angle:" type:#float range:[-999999,999999,0] scale: 0.1  fieldWidth:40 align:#right offset:[0,0] enabled:(groove_animation_type_param ==3)
			label groove_animation_extent "Extent of Movement:" align:#left enabled:(groove_animation_type_param ==4) enabled:(groove_animation_type_param ==5)
			spinner groove_animation_extent_x "" type:#float range:[-999999,999999,0] scale: 0.1 fieldWidth:40 align:#left across:3 enabled:(groove_animation_type_param ==4) enabled:(groove_animation_type_param ==5)
			spinner groove_animation_extent_y "" type:#float range:[-999999,999999,0] scale: 0.1 fieldWidth:40 align:#center enabled:(groove_animation_type_param ==4) enabled:(groove_animation_type_param ==5)
			spinner groove_animation_extent_z "" type:#float range:[-999999,999999,0] scale: 0.1 fieldWidth:40 align:#right enabled:(groove_animation_type_param ==4) enabled:(groove_animation_type_param ==5)
			on groove_animation_type selected i do 
			(
				if i == 1 then
				(
					groove_animation_mode_label.enabled = false
					groove_animation_mode.enabled = false
					groove_animation_speed.enabled = false
					groove_animation_centre.enabled = false
					groove_animation_centre_x.enabled = false
					groove_animation_centre_y.enabled = false
					groove_animation_centre_z.enabled = false
					groove_animation_axis_label.enabled = false
					groove_animation_axis.enabled = false
					groove_animation_angle.enabled = false
					groove_animation_extent.enabled = false
					groove_animation_extent_x.enabled = false
					groove_animation_extent_y.enabled = false
					groove_animation_extent_z.enabled = false
				)
				if i == 2 then
				(
					groove_animation_mode_label.enabled = true
					groove_animation_mode.enabled = true
					groove_animation_speed.enabled = true
					groove_animation_centre.enabled = true
					groove_animation_centre_x.enabled = true
					groove_animation_centre_y.enabled = true
					groove_animation_centre_z.enabled = true
					groove_animation_axis_label.enabled = true
					groove_animation_axis.enabled = true
					groove_animation_angle.enabled = false
					groove_animation_extent.enabled = false
					groove_animation_extent_x.enabled = false
					groove_animation_extent_y.enabled = false
					groove_animation_extent_z.enabled = false
				)
				if i == 3 then
				(
					groove_animation_mode_label.enabled = true
					groove_animation_mode.enabled = true
					groove_animation_speed.enabled = true
					groove_animation_centre.enabled = true
					groove_animation_centre_x.enabled = true
					groove_animation_centre_y.enabled = true
					groove_animation_centre_z.enabled = true
					groove_animation_axis_label.enabled = true
					groove_animation_axis.enabled = true
					groove_animation_angle.enabled = true
					groove_animation_extent.enabled = false
					groove_animation_extent_x.enabled = false
					groove_animation_extent_y.enabled = false
					groove_animation_extent_z.enabled = false
				)
				if i == 4 then
				(
					groove_animation_mode_label.enabled = true
					groove_animation_mode.enabled = true
					groove_animation_speed.enabled = true
					groove_animation_centre.enabled = true
					groove_animation_centre_x.enabled = true
					groove_animation_centre_y.enabled = true
					groove_animation_centre_z.enabled = true
					groove_animation_axis_label.enabled = false
					groove_animation_axis.enabled = false
					groove_animation_angle.enabled = false
					groove_animation_extent.enabled = true
					groove_animation_extent_x.enabled = true
					groove_animation_extent_y.enabled = true
					groove_animation_extent_z.enabled = true
				)
				if i == 5 then
				(
					groove_animation_mode_label.enabled = true
					groove_animation_mode.enabled = true
					groove_animation_speed.enabled = true
					groove_animation_centre.enabled = true
					groove_animation_centre_x.enabled = true
					groove_animation_centre_y.enabled = true
					groove_animation_centre_z.enabled = true
					groove_animation_axis_label.enabled = false
					groove_animation_axis.enabled = false
					groove_animation_angle.enabled = false
					groove_animation_extent.enabled = true
					groove_animation_extent_x.enabled = true
					groove_animation_extent_y.enabled = true
					groove_animation_extent_z.enabled = true
				)
			)
			on groove_animation_mode selected i do
			(
				if i==6 or i==5 then
				(
					groove_animation_speed.enabled = false
				)
				else 
				(
					groove_animation_speed.enabled = true
				)
			)
		)
	)
)