smashable_CA = attributes smashable_data
attribID:#(0xa7ac227, 0x5f123286)
(
	parameters smashable_parameters rollout:smashable_rollout
	(
		smashable_param type:#string
	)
	rollout smashable_rollout "CARMATOOLS - smashable"
	(
		label smashable_label_1 "This node is set as smashable"
	)
)

options.printAllElements = true

global sm_trigger = "undefined"
global sm_texturechange_ui = #()
global sm_replacemodel_ui = #()

global sm_sounds_ui = #() --globals for activating the rollouts
global sm_shrapnel_allui = #()
global sm_shardsshrapnel_ui = #()
global sm_noncarshrapnel_ui = #()
global sm_ghostpartsshrapnel_ui = #()
global sm_actorbased_ui = #()
global sm_sphereclumped_ui = #()
global sm_boxclumped_ui = #()

global sm_explosions_ui = #()
global sm_slicks_ui =#()
global sm_noncars_ui = #()
global sm_sideeffect_ui = #()
global sm_awardcode_ui = #()
global sm_runvar_ui #()

global smash_tab_globals = #(0,"undefined",1,undefined,0,0,0,0)

global conn = #(#(),#(),#(),undefined,#(),#(),0,0,#(),#())
global conn_lvls = #(deepcopy conn)
global cur_conn = 1
	
global txtr_chng_lvl = #(0.005,0,1,"undefined")
global txtr_chng = #("undefined",#(deepcopy txtr_chng_lvl),conn_lvls)

global repl_mod = #(conn_lvls,"petpump.act",100,1,0,0)
	
global smash_tab_shrapnel = #(1,0,0,0.6,0,30,0,2.0,1.5,2.5,0.4,0,"undefined",1,2.5,2.5,2.5,1,-1,-1,100,1,0,0,"&petpump.act",1,"&petpump.act","99petpump.txt")
global smash_tab_explosion = #(1,1,0,0,0,0.25,0,0,0.1,0,0.1,0,0.1,8,8,15,15,1,#())
global smash_tab_slick = #("none",100,100,100,0.2,0.2,0.2,20,20,0.6,0.6,1)
global smash_tab_noncar = #(0,0,1,1,-10,-10,-10,10,10,10,0,0,0,0,0,0,0)
global smash_tab_sideeffect = #(1,1,"*.dat",1,-1.5,-1.5,-1.5,1.5,1.5,1.5,1,4.4)
global smash_tabawardcode = #(1,4500,30,1,1)
global smash_tab_runvar = #(0,0)

global cur_shr = 1
global cur_expl = 1
global cur_nonc = 1
global cur_seff = 1
global cur_runvar = 1

global sm_main_variables = #()	
global sm_shrapnel_variables = #() --globals for updating the rollout
global sm_explosions_variables #()
global sm_explosion_framevariables = #()
global sm_slicks_variables #()

global smashable_importtab = #()
	
global smashable_type = 1
	
fn update_rolloutelement x y  =
(
	if classof x == Spinnercontrol do
	(
		rangemin = x.range.x as integer
		rangemax = x.range.y as integer
		x.range = [rangemin,rangemax,y]
	)
	if classof x == ComboBoxControl do
	(
		x.selection = y
	)
	if classof x == Buttoncontrol do
	(
		x.text = y 
	)
	if classof x == ListBoxControl do
	(
		if classof y == integer do x.selection = y
		if classof y == array do x.items = y
	)
)

fn update_rollout smash_type flags cur_conn =
(
	if smash_type == 1 do
	(
		try
		(
			removesubrollout smashable_setup.sm_sub sm_texturechange
			removesubrollout smashable_setup.sm_sub sm_replacemodel
			removesubrollout smashable_setup.sm_sub sm_sounds
			removesubrollout smashable_setup.sm_sub sm_shrapnels
			removesubrollout smashable_setup.sm_sub sm_explosions
			removesubrollout smashable_setup.sm_sub sm_slicks
			removesubrollout smashable_setup.sm_sub sm_noncars
			removesubrollout smashable_setup.sm_sub sm_sideeffect
			removesubrollout smashable_setup.sm_sub sm_extensions
		)
		catch()
	)
	if smash_type == 2 do
	(
		try
		(
			removesubrollout smashable_setup.sm_sub sm_texturechange
			removesubrollout smashable_setup.sm_sub sm_replacemodel
			removesubrollout smashable_setup.sm_sub sm_sounds
			removesubrollout smashable_setup.sm_sub sm_shrapnels
			removesubrollout smashable_setup.sm_sub sm_explosions
			removesubrollout smashable_setup.sm_sub sm_slicks
			removesubrollout smashable_setup.sm_sub sm_noncars
			removesubrollout smashable_setup.sm_sub sm_sideeffect
			removesubrollout smashable_setup.sm_sub sm_extensions
		)
		catch()
		addsubrollout smashable_setup.sm_sub sm_replacemodel rolledUp:false
		addsubrollout smashable_setup.sm_sub sm_sounds rolledUp:true
		addsubrollout smashable_setup.sm_sub sm_shrapnels rolledUp:true
		addsubrollout smashable_setup.sm_sub sm_explosions rolledUp:true
		addsubrollout smashable_setup.sm_sub sm_slicks rolledUp:true
		addsubrollout smashable_setup.sm_sub sm_noncars rolledUp:true
		addsubrollout smashable_setup.sm_sub sm_sideeffect rolledUp:true
		addsubrollout smashable_setup.sm_sub sm_extensions rolledUp:true
		updateconnotations 1
	)
	if smash_type == 3 do
	(
		try
		(
			removesubrollout smashable_setup.sm_sub sm_texturechange
			removesubrollout smashable_setup.sm_sub sm_replacemodel
			removesubrollout smashable_setup.sm_sub sm_sounds
			removesubrollout smashable_setup.sm_sub sm_shrapnels
			removesubrollout smashable_setup.sm_sub sm_explosions
			removesubrollout smashable_setup.sm_sub sm_slicks
			removesubrollout smashable_setup.sm_sub sm_noncars
			removesubrollout smashable_setup.sm_sub sm_sideeffect
			removesubrollout smashable_setup.sm_sub sm_extensions
		)
		catch()
		addsubrollout smashable_setup.sm_sub sm_sounds rolledUp:true
		addsubrollout smashable_setup.sm_sub sm_shrapnels rolledUp:true
		addsubrollout smashable_setup.sm_sub sm_explosions rolledUp:true
		addsubrollout smashable_setup.sm_sub sm_slicks rolledUp:true
		addsubrollout smashable_setup.sm_sub sm_noncars rolledUp:true
		addsubrollout smashable_setup.sm_sub sm_sideeffect rolledUp:true
		addsubrollout smashable_setup.sm_sub sm_extensions rolledUp:true
		updateconnotations 1
	)
	if smash_type == 4 do
	(
		try
		(
			removesubrollout smashable_setup.sm_sub sm_texturechange
			removesubrollout smashable_setup.sm_sub sm_replacemodel
			removesubrollout smashable_setup.sm_sub sm_sounds
			removesubrollout smashable_setup.sm_sub sm_shrapnels
			removesubrollout smashable_setup.sm_sub sm_explosions
			removesubrollout smashable_setup.sm_sub sm_slicks
			removesubrollout smashable_setup.sm_sub sm_noncars
			removesubrollout smashable_setup.sm_sub sm_sideeffect
			removesubrollout smashable_setup.sm_sub sm_extensions
		)
		catch()
		addsubrollout smashable_setup.sm_sub sm_texturechange rolledUp:false
		addsubrollout smashable_setup.sm_sub sm_sounds rolledUp:true
		addsubrollout smashable_setup.sm_sub sm_shrapnels rolledUp:true
		addsubrollout smashable_setup.sm_sub sm_explosions rolledUp:true
		addsubrollout smashable_setup.sm_sub sm_slicks rolledUp:true
		addsubrollout smashable_setup.sm_sub sm_noncars rolledUp:true
		addsubrollout smashable_setup.sm_sub sm_sideeffect rolledUp:true
		addsubrollout smashable_setup.sm_sub sm_extensions rolledUp:true
		updateconnotations 1
	)
	if sm_main_variables[1] != undefined do sm_main_variables[1].selection = smash_type
	if sm_main_variables[2] != undefined do sm_main_variables[2].range = [0,1,flags]
)

fn updatetexturechange conn_count = 
(
	try sm_texturechange_ui[1].range = [1,9,conn_count] catch()
	try sm_texturechange_ui[2].range = [1,conn_count,cur_conn] catch()
	
	for i = 1 to sm_texturechange_variables.count do
	(
		ui_element = sm_texturechange_variables[i]
		variable = txtr_chng[2][cur_conn][i]
		update_rolloutelement ui_element variable
	)
)

fn updatereplacemodel = 
(
	for i = 2 to sm_replacemodel_variables.count do
	(
		ui_element = sm_replacemodel_variables[i]
		variable = repl_mod[i]
		update_rolloutelement ui_element variable
	)
)

fn updateconnotations cur_conn =
(
	try
	(
		for i=1 to sm_sounds_ui.count do
		(
			ui_element = sm_sounds_ui[i]
			variable = #()
			for i=1 to conn_lvls[cur_conn][1].count do
			(
				sound_id = (conn_lvls[cur_conn][1][i] as string)
				if sound_id.count == 1 do sound_id = "000" + sound_id
				if sound_id.count == 2 do sound_id = "00" + sound_id
				if sound_id.count == 3 do sound_id = "0" + sound_id
				if sound_id.count == 1 do sound_id = sound_id
				append variable sound_id
			)
			update_rolloutelement ui_element variable
		)
		updateshrapnel conn_lvls[cur_conn][2].count 1 
		updateexplosion conn_lvls[cur_conn][3].count 1
		updateslicks conn_lvls[cur_conn][4]
		updatenoncars conn_lvls[cur_conn][5].count 1
		updatesideeffect conn_lvls[cur_conn][6].count 1
		updateawardcode conn_lvls[cur_conn][9][1]
		updaterunvar conn_lvls[cur_conn][10].count 1
	)
	catch()
)

fn updateshrapnel  shrapnel_count cur_shrp =
(
	try (sm_shrapnel_allui[1]).range = [0,9,shrapnel_count] catch()
	try (sm_shrapnel_allui[2]).range = [0,shrapnel_count,cur_shrp] catch()
	
	for i = 2 to sm_shrapnel_allui.count do
	(
		if sm_shrapnel_allui[i] != undefined do sm_shrapnel_allui[i].enabled = false
	)
	
	if shrapnel_count < conn_lvls[cur_conn][2].count do
	(
		deleteitem conn_lvls[cur_conn][2] conn_lvls[cur_conn][2].count
	)
	if shrapnel_count > conn_lvls[cur_conn][2].count do
	(
		append conn_lvls[cur_conn][2] (deepcopy smash_tab_shrapnel)
	)
	
	if shrapnel_count == 0 then
	(
		conn_lvls[cur_conn][2] = #()
		global cur_shrp = 1
	)
	else
	(
		shrapnel_type = conn_lvls[cur_conn][2][cur_shrp][1] 
		shrapnel_placement = conn_lvls[cur_conn][2][cur_shrp][14]
	
		if shrapnel_type == 1 do
		(
			for i = 1 to sm_shardsshrapnel_ui.count do
			(
				if sm_shardsshrapnel_ui[i] != undefined do sm_shardsshrapnel_ui[i].enabled = true
			)
		)
		if shrapnel_type == 2 do
		(
			for i = 1 to sm_noncarshrapnel_ui.count do
			(
				if sm_noncarshrapnel_ui[i] != undefined do sm_noncarshrapnel_ui[i].enabled = true
			)
			if shrapnel_placement == 2 do
			(
				for i=1 to sm_sphereclumped_ui.count do
				(
					if sm_sphereclumped_ui[i] != undefined do sm_sphereclumped_ui[i].enabled = true
				)
			)
			if shrapnel_placement  == 3 do
			(
				for i=1 to sm_boxclumped_ui.count do
				(
					if sm_boxclumped_ui[i] != undefined do sm_boxclumped_ui[i].enabled = true
				)
			)
		)
		if shrapnel_type == 3 do
		(
			for i = 1 to sm_ghostpartsshrapnel_ui.count do
			(
				if sm_ghostpartsshrapnel_ui[i] != undefined do sm_ghostpartsshrapnel_ui[i].enabled = true
			)
			if shrapnel_placement == 2 do
			(
				for i=1 to sm_sphereclumped_ui.count do
				(
					if sm_sphereclumped_ui[i] != undefined do sm_sphereclumped_ui[i].enabled = true
				)
			)
			if shrapnel_placement == 3 do
			(
				for i=1 to sm_boxclumped_ui.count do
				(
					if sm_boxclumped_ui[i] != undefined do sm_boxclumped_ui[i].enabled = true
				)
			)
		)
		for i=1 to sm_shrapnel_variables.count do
		(
			ui_element = sm_shrapnel_variables[i]
			variable = conn_lvls[cur_conn][2][cur_shrp][i]
			update_rolloutelement ui_element variable
		)
	)
)

fn updateexplosion explosion_count cur_expl =
(
	try sm_explosions_ui[1].range = [0,9,explosion_count] catch()
	try sm_explosions_ui[2].range = [0,explosion_count,cur_expl] catch()
	
	if explosion_count < conn_lvls[cur_conn][3].count do --delete an element if the count is decreased
	(
		deleteitem conn_lvls[cur_conn][3] conn_lvls[cur_conn][3].count
	)
	
	if explosion_count > conn_lvls[cur_conn][3].count do --delete an element if the count is decreased
	(
		append conn_lvls[cur_conn][3] (deepcopy smash_tab_explosion )
	)
	
	if explosion_count == 0 then --remove explosions if count set to zero
	(
		conn_lvls[cur_conn][3] = #()
		global cur_expl = 1
		for i = 2 to sm_explosions_ui.count do
		(
			if sm_explosions_ui[i] != undefined do sm_explosions_ui[i].enabled = false
		)
	)
	else
	(
		for i = 2 to sm_explosions_ui.count do --enable the rollout elements
		(
			if sm_explosions_ui[i] != undefined do sm_explosions_ui[i].enabled = true
		)
		for i = 1 to sm_explosions_variables.count do --set explosion values to the rollout elements
		(
			ui_element = sm_explosions_variables[i]
			variable = conn_lvls[cur_conn][3][cur_expl][i]
			update_rolloutelement ui_element variable
		)
		if conn_lvls[cur_conn][3][cur_expl][19].count > 0 then --set the frames tab
		(
			frames = #()
			opacities = #()
			for j=1 to conn_lvls[cur_conn][3][cur_expl][19].count do
			(
				append frames (conn_lvls[cur_conn][3][cur_expl][19][j][1] as string)
				append opacities (conn_lvls[cur_conn][3][cur_expl][19][j][2] as string)
			)
			sm_explosion_framevariables[1].items = frames
			sm_explosion_framevariables[2].items = opacities
		)
		else 
		(
			sm_explosion_framevariables[1].items = #()
			sm_explosion_framevariables[2].items = #()
		)
	)
)

fn updateslicks slick_mat =
(
	if slick_mat == undefined then
	(
		for i = 1 to sm_slicks_ui.count do
		(
			if sm_slicks_ui[i] != undefined do sm_slicks_ui[i].enabled = false
		)
	)
	else 
	(
		for i = 1 to sm_slicks_ui.count do
		(
			if sm_slicks_ui[i] != undefined do sm_slicks_ui[i].enabled = true
		)
		for i=1 to sm_slicks_variables.count do
		(
			ui_element = sm_slicks_variables[i]
			variable = conn_lvls[cur_conn][4][i]
			update_rolloutelement ui_element variable
		)
	)
	
)

fn updatenoncars noncars_count cur_nonc =
(
	try sm_noncars_ui[1].range = [0,9,noncars_count] catch()
	try sm_noncars_ui[2].range = [1,noncars_count,cur_nonc] catch()
	
	if noncars_count < conn_lvls[cur_conn][5].count do --remove an entry if the number is decreased
	(
		deleteitem conn_lvls[cur_conn][5] conn_lvls[cur_conn][5].count
	)
	
	if noncars_count > conn_lvls[cur_conn][5].count do --remove an entry if the number is decreased
	(
		append conn_lvls[cur_conn][5] (deepcopy smash_tab_noncar)
	)
	
	if noncars_count == 0 then --when zero entries, delete all of them and disable rollout elements
	(
		conn_lvls[cur_conn][5] = #()
		global cur_nonc = 1
		for i = 2 to sm_noncars_ui.count do
		(
			if sm_noncars_ui[i] != undefined do sm_noncars_ui[i].enabled = false
		)
	)
		
	else
	(
		for i = 2 to sm_noncars_ui.count do --enable rollout
		(
			if sm_noncars_ui[i] != undefined do sm_noncars_ui[i].enabled = true
		)
		for i=1 to sm_noncars_variables.count do --fill in rollout with current element
		(
			ui_element = sm_noncars_variables[i]
			variable = conn_lvls[cur_conn][5][cur_nonc][i]
			update_rolloutelement ui_element variable
		)
	)
)

fn updatesideeffect seffect_count cur_seff =
(
	try sm_sideeffect_ui[1].range = [0,9,seffect_count] catch()
	try sm_sideeffect_ui[2].range = [1,seffect_count,cur_seff] catch()
	
	if seffect_count < conn_lvls[cur_conn][6].count do --remove an entry if the number is decreased
	(
		deleteitem conn_lvls[cur_conn][6] conn_lvls[cur_conn][6].count
	)
	if seffect_count > conn_lvls[cur_conn][6].count do --remove an entry if the number is decreased
	(
		append conn_lvls[cur_conn][6] (deepcopy smash_tab_sideeffect)
	)
	
	if seffect_count == 0 then
	(
		conn_lvls[cur_conn][6] = #()
		global cur_seff = 1
		for i=2 to sm_sideeffect_ui.count do
		(
			if sm_sideeffect_ui[i] != undefined do sm_sideeffect_ui[i].enabled = false
		)
	)
	
	else
	(
		for i = 1 to sm_sideeffect_ui.count do
		(
			if sm_sideeffect_ui[i] != undefined do sm_sideeffect_ui[i].enabled = true
		)
		for i=1 to sm_sideeffect_variables.count do --fill in rollout with current element
		(
			ui_element = sm_sideeffect_variables[i]
			variable = conn_lvls[cur_conn][6][cur_seff][i]
			update_rolloutelement ui_element variable
		)
	)
)

fn updaterunvar runvar_count cur_runvar =
(
	try sm_runvar_ui[1].range = [0,9,runvar_count] catch()
	try sm_runvar_ui[2].range = [0,runvar_count,cur_runvar] catch()
	
	if runvar_count < conn_lvls[cur_conn][10].count do
	(
		deleteitem conn_lvls[cur_conn][10] conn_lvls[cur_conn][10].count
	)
	if runvar_count > conn_lvls[cur_conn][10].count do
	(
		append conn_lvls[cur_conn][10] (deepcopy  smash_tab_runvar )
	)
		
	if runvar_count == 0 then
	(
		conn_lvls[cur_conn][10] = #()
		global cur_runvar = 1
		try
		(
			for i=2 to sm_runvar_ui.count do
			(
				if sm_runvar_ui[i] != undefined do sm_runvar_ui[i].enabled = false
			)
		)
		catch()
	)
	else
	(
		for i = 1 to sm_runvar_ui.count do
		(
			if sm_runvar_ui[i] != undefined do sm_runvar_ui[i].enabled = true
		)
		update_rolloutelement sm_runvar_ui[3] conn_lvls[cur_conn][10][cur_runvar][1]
		update_rolloutelement sm_runvar_ui[4] conn_lvls[cur_conn][10][cur_runvar][2]
	)
)

fn updateawardcode award_type =
(
	if award_type == 1 or award_type == undefined  then
	(
		conn_lvls[cur_conn][9] = #()
		for i = 2 to sm_awardcode_ui.count do
		(
			if sm_awardcode_ui[i] != undefined do sm_awardcode_ui[i].enabled = false
		)
	)
	else
	(
		if conn_lvls[cur_conn][9][1] == undefined do conn_lvls[cur_conn][9] = (deepcopy smash_tabawardcode)
		conn_lvls[cur_conn][9][1] = award_type
		for i = 2 to sm_awardcode_ui.count do
		(
			if sm_awardcode_ui[i] != undefined do sm_awardcode_ui[i].enabled = true
		)
		for i=1 to sm_awardcode_ui.count do
		(
			ui_element = sm_awardcode_ui[i]
			variable = conn_lvls[cur_conn][9][i]
			update_rolloutelement ui_element variable
		)
	)
)

rollout smashable_setup "Smashable setup"
(
	group "globals"
	(
		label sm_label "" align:#right
		label sm_gl_trig_mod_label "select trigger model" align:#right across:2 
		pickbutton sm_gl_trig_mod "undefined" autoDisplay:true width:145 align:#right
		label sm_gl_trig_mat_label "select trigger material" align:#right across:2
		button sm_gl_trig_mat "undefined" width:145 align:#right
		dropdownlist sm_type "smashable type:" items:#("Nochange","Replacemodel","Remove","Texturechange") width:145 align:#right across:2
		spinner sm_global_flags "flags:" range:[0,2,0] type:#integer offset:[0,20] fieldwidth:30
	)
	subrollout sm_sub "sm_sub" width:352 offset:[-9,0]
	button sm_apply "Apply"width:145 across:2 tooltip:"aplly on object. rightclick to remove" offset:[0,504]
	on sm_apply pressed do
	(
		trigger_model = getnodebyname sm_trigger
		trigger_material = medit.getcurmtl()
		if trigger_model != undefined do
		(
			smashable_string = smash_tab_globals as string
			custattributes.add trigger_model smashable_CA
			trigger_model.smashable_data.smashable_param = smashable_string
			try smash_tab_globals[2] = trigger_model.name catch()
		)
		if trigger_material != undefined do
		(
			smashable_string = smash_tab_globals as string
			custattributes.add trigger_material smashable_CA
			trigger_material.smashable_data.smashable_param = smashable_string
			try smash_tab_globals[2] = trigger_material.name catch()
		)
	)
		
	button sm_cancel "Cancel" width:145 tooltip:"apply on material. rightclick to remove" offset:[0,504]
	on smashable_setup open do
	(
		global sm_main_variables = #(sm_type,sm_global_flags)
		global sm_texturechange_ui = #(sm_levels,sm_cur_level,sm_bitmap1_label,sm_bitmap1_picker,sm_bitmap2_label,sm_bitmap2_picker,sm_threshhold,sm_coltype_label,sm_coltype,sm_flag)
		global sm_replacemodel_ui = #(sm_replacemodel_label,sm_replacemodel,sm_replace_firechance,sm_replace_firecollumns,sm_replace_min,sm_replace_max)
	)
	
	on sm_gl_trig_mod picked obj do
	(
		if obj != undefined do
		(
			sm_gl_trig_mat.text = "undefined"
			sm_trigger = obj.name
			if custattributes.get obj smashable_CA != undefined then
			(
				global smashable_importtab = (execute obj.smashable_data.smashable_param)
				global smash_tab_globals = smashable_importtab
				smash_tab_globals[2] = obj.name
				
				if smash_tab_globals[3] == 1 do
				(
					smash_tab_globals[4] = undefined
					update_rollout smash_tab_globals[3] smash_tab_globals[1]
				)
				if smash_tab_globals[3] == 2 do
				(
					global repl_mod = smash_tab_globals[4]
					global conn_lvls = repl_mod[1]
					global cur_conn = 1
					update_rollout smash_tab_globals[3] smash_tab_globals[1] cur_conn
					updatereplacemodel
				)
				if smash_tab_globals[3] == 3 do 
				(
					conn_lvls = smash_tab_globals[4]
					update_rollout smash_tab_globals[3] smash_tab_globals[1] cur_conn
				)
				if smash_tab_globals[3] == 4 do 
				(
					global txtr_chng = smash_tab_globals[4]
					global conn_lvls = txtr_chng[3]
					update_rollout smash_tab_globals[3] smash_tab_globals[1] cur_conn
					updatetexturechange conn_lvls.count
				)
			)
		)
	)
	on sm_gl_trig_mat pressed do
	(
		mat = medit.getcurmtl()
		if mat != undefined do
		(
			sm_gl_trig_mod.text = "undefined"
			sm_gl_trig_mat.text = mat.name
			sm_trigger = mat.name
			
			if custattributes.get mat smashable_CA != undefined then
			(
				global smashable_importtab = (execute mat.smashable_data.smashable_param)
				global smash_tab_globals = smashable_importtab
				smash_tab_globals[2] = mat.name
				
				if smash_tab_globals[3] == 1 do
				(
					smash_tab_globals[4] = undefined
					update_rollout smash_tab_globals[3] smash_tab_globals[1]
				)
				if smash_tab_globals[3] == 2 do
				(
					global repl_mod = smash_tab_globals[4]
					global conn_lvls = repl_mod[1]
					global cur_conn = 1
					update_rollout smash_tab_globals[3] smash_tab_globals[1] cur_conn
					updatereplacemodel
				)
				if smash_tab_globals[3] == 3 do 
				(
					conn_lvls = smash_tab_globals[4]
					update_rollout smash_tab_globals[3] smash_tab_globals[1] cur_conn
				)
				if smash_tab_globals[3] == 4 do 
				(
					global txtr_chng = smash_tab_globals[4]
					global conn_lvls = txtr_chng[3]
					update_rollout smash_tab_globals[3] smash_tab_globals[1] cur_conn
					updatetexturechange conn_lvls.count
				)
			)
		)
	)
	on sm_type selected i do
	(
		global cur_conn = 1
		if i==1 do
		(
			smash_tab_globals[4] = undefined
		)
		if i==2 do
		(
			smash_tab_globals[4] = repl_mod
			repl_mod[1] = conn_lvls
		)
		if i==3 do
		(
			smash_tab_globals[4] = conn_lvls
		)
		if i==4 do
		(
			smash_tab_globals[4] = txtr_chng
			txtr_chng[3]=conn_lvls
		)
		smash_tab_globals[3] = i
		update_rollout i 1 1
		global smashable_type = i --use this to check whether an update of the entire rollout is needed or not
	)
	on sm_cancel pressed do
	(
		destroydialog smashable_setup
	)
	on sm_global_flags changed val do
	(
		smash_tab_globals[1] = val
	)
)

rollout sm_texturechange "Texturechange options:"
(
	group "global texturechange options"
	(
		spinner sm_levels "total number of smashable connotation levels:" range:[1,9,1] type:#integer fieldwidth:30
		label sm_bitmap1_label "choose alternative start bitmap:" across:2 align:#right 
		button sm_bitmap1_picker "undefined" width:145 align:#right tooltip:"If you do not want the bitmap in the original identifier material"
		label sm_txtr_chng_lbl1 ""
	)
	group "texturechange level properties"
	(
		spinner sm_cur_level "current editing level:" range:[1,1,1] type:#integer fieldwidth:30 tooltip:"change the current smashable editing level (connotations will also change)"
		label sm_bitmap2_label "level ending bitmap:" across:2 align:#right 
		button sm_bitmap2_picker "undefined" width:145 align:#right tooltip:"each level with get a new bitmap, e.g. normal, cracked, shattered"
		spinner sm_threshhold "trigger threshold:" range:[0,1,0.005] fieldwidth:40 type:#float scale:0.005 tooltip:"the ease of cracking. The larger the harder"
		label sm_coltype_label "collision type:" across:2 align:#right
		dropdownlist sm_coltype "" items:#("solid","passthrough") width:145 align:#right tooltip:"the collistion type of the texture after the smash"
		spinner sm_flag "flags:" range:[0,1,1] fieldwidth:30 type:#integer tooltip:"this doesn't do squat"
	)
	on sm_texturechange open do
	(
		global sm_texturechange_ui = #(sm_levels,sm_cur_level,sm_bitmap1_label,sm_bitmap1_picker,sm_bitmap2_label,sm_bitmap2_picker,sm_threshhold,sm_coltype_label,sm_coltype,sm_flag)
		global sm_texturechange_variables = #(sm_threshhold,sm_flag,sm_coltype,sm_bitmap2_picker)
	)
	on sm_bitmap1_picker pressed do
	(
		bitmapname = getOpenFileName()
		if bitmapname != undefined do
		(
			bitmapname = getfilenamefile bitmapname
			txtr_chng[1] = bitmapname
			sm_bitmap1_picker.text = bitmapname as string
		)
	)
	on sm_bitmap2_picker pressed do
	(
		bitmapname = getOpenFileName()
		if bitmapname != undefined do
		(
			bitmapname = getfilenamefile bitmapname
			txtr_chng[2][sm_cur_level.value][4] = bitmapname
			sm_bitmap2_picker.text = bitmapname as string
		)
	)
	on sm_levels changed val do
	(
		if val <sm_cur_level.value then sm_cur_level.range = [1,val,val]
		else sm_cur_level.range = [1,val,sm_cur_level.value]
		if val< txtr_chng[2].count then
		(
			count = txtr_chng[2].count
			deleteitem txtr_chng[2] count
			deleteitem conn_lvls count
			cur_conn = conn_lvls.count
		)
		else
		(
			if val> txtr_chng[2].count do
			(
				append txtr_chng[2] (deepcopy txtr_chng_lvl)
				append conn_lvls (deepcopy conn)
			)
		)
		--for i=1 to sm_texturechange_variables.count do
		--(
		--	ui_element = sm_texturechange_variables[i]
		--	variable = txtr_chng[2][val][i]
		--	update_rolloutelement ui_element variable
		--)
		updateconnotations sm_cur_level.value
	)
	on sm_cur_level changed val do
	(
		for i=1 to sm_texturechange_variables.count do
		(
			cur_conn = val
			ui_element = sm_texturechange_variables[i]
			variable = txtr_chng[2][cur_conn][i]
			update_rolloutelement ui_element variable
		)
		updateconnotations val
	)
	on sm_threshhold changed val do
	(
		txtr_chng[2][sm_cur_level.value][1] = val
	)
	on sm_flag changed val do
	(
		txtr_chng[2][sm_cur_level.value][2] = val
	)
	on sm_coltype selected i do
	(
		txtr_chng[2][sm_cur_level.value][3] = i
	)
)

rollout sm_replacemodel "Replacemodel options:"
(
	group "Recplacemodel options:"
	(
		label sm_replacemodel_label "pick a replacement model:" align:#right across:2
		pickbutton sm_replacemodel_picker "undefined" width:145 align:#right
		spinner sm_replace_firechance "chance of fire/smoke %:" range:[0,100,100] type:#integer fieldwidth:30
		spinner sm_replace_firecollumns "number of fire/smoke collumns:" range:[0,9,1] type:#integer fieldwidth:30
		spinner sm_replace_firemin "min/max smokiness:" range:[0,3,0] type:#integer fieldwidth:30 across:2 offset:[120,0]
		spinner sm_replace_firemax range:[0,3,0] type:#integer fieldwidth:30
	)
	on sm_replacemodel open do
	(
		global sm_replacemodel_ui = #(sm_replacemodel_label,sm_replacemodel_picker,sm_replace_firechance,sm_replace_firecollumns,sm_replace_firemin,sm_replace_firemax)
		global sm_replacemodel_variables = #("",sm_replacemodel_picker,sm_replace_firechance,sm_replace_firecollumns,sm_replace_min,sm_replace_max)
		for i=1 to sm_replacemodel_variables.count do
		(
			ui_element = sm_replacemodel_variables[i]
			variable = repl_mod[i]
			update_rolloutelement ui_element variable
		)
	)
	--#("petpump.act",100,1,0,0)
	on sm_replacemodel_picker picked obj do
	(
		if obj !=undefined do
		(
			sm_replacemodel_picker.text = obj.name
			repl_mod[2] = obj.name
		)
	)
	on sm_replace_firechance changed val do repl_mod[3] = val
	on sm_replace_firecollumns changed val do repl_mod[4] = val
	on sm_replace_firemin changed val do repl_mod[5] = val
	on sm_replace_firemax changed val do repl_mod[6] = val
)

rollout sm_sounds "Sounds:"
(
	button sm_sound_list "sound list reference" width:145 across:2 align:#left 
	listbox sm_sounds "" items:#() height:6 selection:1
	spinner sm_sound_edit range:[0000,9999,0000] type:#integer align:#left fieldwidth:135 offset:[0,-48]
	button sm_sounds_add "add" across:2 offset:[0,0] align:#left width:65
	button sm_sounds_delete "delete" offset:[-120,0] width:65
	on sm_sounds open do
	(
		global sm_sounds_ui = #(sm_sounds)
		tmp_sounds = #()
		for i=1 to conn_lvls[cur_conn][1].count do
		(
			sound_id = (conn_lvls[cur_conn][1][i] as string)
			if sound_id.count == 1 do sound_id = "000" + sound_id
			if sound_id.count == 2 do sound_id = "00" + sound_id
			if sound_id.count == 3 do sound_id = "0" + sound_id
			if sound_id.count == 1 do sound_id = sound_id
			append tmp_sounds sound_id
		)
		sm_sounds.items = tmp_sounds
	)
	
	on sm_sounds_add pressed do
	(
		tmp_sounds = sm_sounds.items
		append tmp_sounds "0000"
		sm_sounds.items = tmp_sounds
		
		append conn_lvls[cur_conn][1] "0000"
	)
	on sm_sounds_delete pressed do
	(
		if sm_sounds.items.count != 0 do
		(
			tmp_sounds = sm_sounds.items
			deleteitem conn_lvls[cur_conn][1] sm_sounds.selection
			deleteitem tmp_sounds sm_sounds.selection
			sm_sounds.items = tmp_sounds
		)
	)
	on sm_sound_edit changed val do
	(
		if sm_sounds.selection != 0 do
		(
			tmp_sounds = sm_sounds.items
			sound_id = sm_sound_edit.value as string
			if sound_id.count == 1 do sound_id = "000" + (sm_sound_edit.value as string)
			if sound_id.count == 2 do sound_id = "00" + (sm_sound_edit.value as string)
			if sound_id.count == 3 do sound_id = "0" + (sm_sound_edit.value as string)
			if sound_id.count == 1 do sound_id = (sm_sound_edit.value as string)
			tmp_sounds[sm_sounds.selection] = sound_id
			sm_sounds.items = tmp_sounds
			conn_lvls[cur_conn][1][sm_sounds.selection] = sound_id
		)
	)
)

rollout sm_shrapnels "Shrapnels:"
(
	spinner sm_shrapnel "number of shrapnels" range:[0,9,0] type:#integer fieldwidth:40 offset:[0,3]
	spinner sm_cur_shrp "current edit shrapnel:" range:[1,1,1] type:#integer fieldwidth:40 offset:[0,3] enabled:false

	label sm_shrapnel_type_label "shrapnel type:" across:2 align:#right offset:[0,3] enabled:false 
	dropdownlist sm_shrapnel_type "" items:#("shards","noncars","ghostparts") width:145 align:#right enabled:false
	spinner sm_min_tocar "min/max speed towards car:" range:[0,10,0] type:#float scale:0.01 fieldwidth:40 across:2 offset:[90,0]
	spinner sm_max_tocar range:[0,10,0] type:#float scale:0.01 fieldwidth:40
	spinner sm_imp_velo "impact velocity factor:" range:[0,10,1] type:#float scale:0.01 fieldwidth:40 align:#right
	spinner sm_rand_velo "random velocity:" range:[0,10,10] type:#float scale:0.01 fieldwidth:40 align:#right
	spinner sm_randup_velo "random up velocity:" range:[0,10,2] type:#float scale:0.01 fieldwidth:40 align:#right
	spinner sm_norm_velo "random normal velocity:" range:[0,10,0] type:#float scale:0.01 fieldwidth:40 align:#right
	spinner sm_spinrate "random spin rate:" range:[0,999999,100] type:#integer fieldwidth:40 align:#right
	spinner sm_min_time "min/max lifespan:" range:[0,10,.75] type:#float scale:0.01 fieldwidth:40 across:2 offset:[90,0]
	spinner sm_max_time range:[0,10,1.25] type:#float scale:0.01 fieldwidth:40
	spinner sm_cutlength "min cut length:" range:[0,10,0.005] type:#float scale:0.001 fieldwidth:40 align:#right
	spinner sm_shrapnel_flag "flags:"range:[0,1,0] type:#integer fieldwidth:40
	label sm_shrapnel_bitmap_label "pick a bitmap file:" across:2 align:#right offset:[0,3]
	button sm_shrapnel_bitmap "bitmap:" width:145 align:#right
	group "shrapnel placement:"
	(
		label sm_shrapnel_placement_label "shrapnel placement:" across:2 align:#right offset:[0,3]
		dropdownlist sm_shrapnel_placement "" items:#("actorbased","sphereclumped","boxclumped") width:145 align:#right
		spinner sm_shrapnel_radius "clumping radius:" range:[0,9999,2.5] fieldwidth:40 type:#float scale:0.01
		spinner sm_shrapnel_height "clumping height:" range:[0,9999,2.5] fieldwidth:40 type:#float scale:0.01
		spinner sm_shrapnel_width "clumping width/length:" range:[0,9999,2.5] fieldwidth:40 type:#float scale:0.01
		label sm_clumping_centre_label "clumping centre:" align:#right across:2 offset:[0,3]
		dropdownlist sm_clumping_centre "" items:#("impact","model") width:145 align:#right
	)
	spinner sm_shrapnelbits_min "min/max number of shrapnel bits:" range:[-1,10,-1] type:#integer fieldwidth:30 across:2 offset:[110,0]
	spinner sm_shrapnelbits_max range:[-1,10,-1] type:#integer fieldwidth:30
	spinner sm_shrapnel_firechance "chance of fire/smoke %" range:[0,100,100] type:#integer fieldwidth:40
	spinner sm_shrapnel_firecollumns "number of fire/smoke collumns:" range:[0,9,1] type:#integer fieldwidth:30
	spinner sm_shrapnel_firemin "min/max smokiness:" range:[0,3,0] type:#integer fieldwidth:30 across:2 offset:[120,0]
	spinner sm_shrapnel_firemax range:[0,3,0] type:#integer fieldwidth:30
	label sm_shrapnel_model_label "ACT,DAT,MAT for shrapnel:" across:2 align:#right offset:[0,3]
	button sm_shrapnel_model "undefined" width:145 align:#right
	spinner sm_shranel_actornumber "number of seperate actors in file:" range:[0,1,1] fieldwidth:30
	label sm_shrapnel_actor_label "Shrapnel actorname:" across:2 align:#right offset:[0,3]
	button sm_shrapnel_actor "undefined" width:145 align:#right
	label sm_shrapnel_noncartxt_label "noncar textfile for actor:" across:2 align:#right offset:[0,3]
	button sm_shrapnel_noncartxt "undefined" width:145 align:#right
	on sm_shrapnels open do
	(
		global sm_shrapnel_allui = #(sm_shrapnel,sm_cur_shrp,sm_shrapnel_type_label,sm_shrapnel_type,sm_min_tocar,sm_max_tocar,sm_imp_velo,sm_rand_velo,sm_randup_velo,sm_norm_velo,sm_spinrate,sm_min_time,sm_max_time,sm_cutlength,sm_shrapnel_flag,sm_shrapnel_bitmap_label,sm_shrapnel_bitmap,sm_shrapnel_placement_label,sm_shrapnel_placement,sm_shrapnelbits_min,sm_shrapnelbits_max,sm_shrapnel_firechance,sm_shrapnel_firecollumns,sm_shrapnel_firemin,sm_shrapnel_firemax,sm_shrapnel_model_label,sm_shrapnel_model,sm_shranel_actornumber,sm_shrapnel_actor_label,sm_shrapnel_actor,sm_shrapnel_noncartxt_label,sm_shrapnel_noncartxt,sm_shrapnel_radius,sm_shrapnel_height,sm_shrapnel_width,sm_clumping_centre_label,sm_clumping_centre)
		global sm_noncarshrapnel_ui = #(sm_cur_shrp,sm_shrapnel_type_label,sm_shrapnel_type,sm_min_tocar,sm_max_tocar,sm_imp_velo,sm_rand_velo,sm_randup_velo,sm_norm_velo,sm_spinrate,sm_shrapnel_placement_label,sm_shrapnel_placement,sm_shrapnelbits_min,sm_shrapnelbits_max,sm_shrapnel_firechance,sm_shrapnel_firecollumns,sm_shrapnel_firemin,sm_shrapnel_firemax,sm_shrapnel_model_label,sm_shrapnel_model,sm_shranel_actornumber,sm_shrapnel_actor_label,sm_shrapnel_actor,sm_shrapnel_noncartxt_label,sm_shrapnel_noncartxt)
		global sm_shardsshrapnel_ui = #(sm_cur_shrp,sm_shrapnel_type_label,sm_shrapnel_type,sm_min_tocar,sm_max_tocar,sm_imp_velo,sm_rand_velo,sm_randup_velo,sm_norm_velo,sm_spinrate,sm_min_time,sm_max_time,sm_cutlength,sm_shrapnel_flag,sm_shrapnel_bitmap_label,sm_shrapnel_bitmap)
		global sm_ghostpartsshrapnel_ui = #(sm_cur_shrp,sm_shrapnel_type_label,sm_shrapnel_type,sm_min_tocar,sm_max_tocar,sm_imp_velo,sm_rand_velo,sm_randup_velo,sm_norm_velo,sm_spinrate,sm_shrapnel_placement_label,sm_shrapnel_placement,sm_shrapnelbits_min,sm_shrapnelbits_max,sm_shrapnel_model_label,sm_shrapnel_model)
		global sm_actorbased_ui = #()
		global sm_sphereclumped_ui = #(sm_shrapnel_radius,sm_clumping_centre_label,sm_clumping_centre)
		global sm_boxclumped_ui = #(sm_shrapnel_height,sm_shrapnel_width,sm_clumping_centre_label,sm_clumping_centre)
		
		global sm_shrapnel_variables = #(sm_shrapnel_type,sm_min_tocar,sm_max_tocar,sm_imp_velo,sm_rand_velo,sm_randup_velo,sm_norm_velo,sm_spinrate,sm_min_time,sm_max_time,sm_cutlength,sm_shrapnel_flag,sm_shrapnel_bitmap,sm_shrapnel_placement,sm_shrapnel_radius,sm_shrapnel_height,sm_shrapnel_width,sm_clumping_centre,sm_shrapnelbits_min,sm_shrapnelbits_max,sm_shrapnel_firechance,sm_shrapnel_firecollumns,sm_shrapnel_firemin,sm_shrapnel_firemax,sm_shrapnel_model,sm_shranel_actornumber,sm_shrapnel_actor,sm_shrapnel_noncartxt)
		global cur_shrp
	) 
	on sm_shrapnel changed val do
	(
		updateshrapnel val cur_shrp
	)
	on sm_cur_shrp changed val do
	(
		global cur_shrp = val
		updateshrapnel sm_shrapnel.value val
	)
	
	on sm_shrapnel_type selected i do
	(
		conn_lvls[cur_conn][2][cur_shr][1] = i
		updateshrapnel sm_shrapnel.value cur_shr
	)
	
	on sm_min_tocar changed i do conn_lvls[cur_conn][2][cur_shr][2] = i
	on sm_max_tocar changed i do conn_lvls[cur_conn][2][cur_shr][3] = i
	on sm_imp_velo changed i do conn_lvls[cur_conn][2][cur_shr][4] = i
	on sm_rand_velo changed i do conn_lvls[cur_conn][2][cur_shr][5] = i
	on sm_randup_velo changed i do conn_lvls[cur_conn][2][cur_shr][6] = i
	on sm_norm_velo changed i do conn_lvls[cur_conn][2][cur_shr][7] = i
	on sm_spinrate changed i do conn_lvls[cur_conn][2][cur_shr][8] = i
	on sm_min_time changed i do conn_lvls[cur_conn][2][cur_shr][9] = i
	on sm_max_time changed i do conn_lvls[cur_conn][2][cur_shr][10] = i
	on sm_cutlength changed i do conn_lvls[cur_conn][2][cur_shr][11] = i
	on sm_shrapnel_flag changed i do conn_lvls[cur_conn][2][cur_shr][12] = i
	on sm_shrapnel_bitmap pressed do
	(
		bitmapname = getOpenFileName()
		if bitmapname != undefined do
		(
			bitmapname = getfilenamefile bitmapname
			conn_lvls[cur_conn][2][cur_shr][13] = bitmapname
			sm_shrapnel_bitmap.text = bitmapname as string
		)
	)
	
	on sm_shrapnel_placement selected i do
	(
		conn_lvls[cur_conn][2][cur_shr][14] = i
		updateshrapnel sm_shrapnel.value cur_shrp
	)
	on sm_shrapnel_radius changed i do conn_lvls[cur_conn][2][cur_shr][15] = i
	on sm_shrapnel_height changed i do conn_lvls[cur_conn][2][cur_shr][16] = i
	on sm_shrapnel_width changed i do conn_lvls[cur_conn][2][cur_shr][17] = i
	on sm_clumping_centre changed i do conn_lvls[cur_conn][2][cur_shr][18] = i
	on sm_shrapnelbits_min changed i do conn_lvls[cur_conn][2][cur_shr][19] = i
	on sm_shrapnelbits_max changed i do conn_lvls[cur_conn][2][cur_shr][20] = i
	on sm_shrapnel_firechance changed i do conn_lvls[cur_conn][2][cur_shr][21] = i
	on sm_shrapnel_firecollumns changed i do conn_lvls[cur_conn][2][cur_shr][22] = i
	on sm_shrapnel_firemin changed i do conn_lvls[cur_conn][2][cur_shr][23] = i
	on sm_shrapnel_firemax changed i do conn_lvls[cur_conn][2][cur_shr][24] = i
	on sm_shrapnel_model pressed do
	(
		actorname = getOpenFileName()
		if actorname != undefined do
		(
			actorname = (getfilenamefile actorname) + (getfilenametype actorname)
		)
		sm_shrapnel_model.text = actorname as string
		sm_shrapnel_actor.text = actorname as string
		
		conn_lvls[cur_conn][2][cur_shr][25] =  actorname as string
		conn_lvls[cur_conn][2][cur_shr][27] =  actorname as string
	)
	on sm_shranel_actornumber changed i do conn_lvls[cur_conn][2][cur_shr][26] = i
	on sm_shrapnel_noncartxt pressed do
	(
		txtname = getOpenFileName()
		if txtname != undefined do
		(
			txtname = (getfilenamefile txtname) + (getfilenametype txtname)
		)
		sm_shrapnel_noncartxt.text = txtname as string
		conn_lvls[cur_conn][2][cur_shr][28] =  txtname as string
	)
)

rollout sm_explosions "Explosions:"
(
	spinner sm_explosions "number of explosion groups:" range:[0,9,0] type:#integer fieldwidth:40 offset:[0,3]
	spinner sm_cur_expl "current edit explosion:" range:[1,1,1] type:#integer fieldwidth:40 offset:[0,3]
	
	spinner sm_min_explosions "min/max count of explosion 'clouds':" range:[0,10,1] type:#integer fieldwidth:40 across:2 offset:[90,0] enabled:false
	spinner sm_max_explosions range:[0,10,1] type:#integer fieldwidth:40 enabled:false
	spinner sm_min_expl_delay "min/max start delay:" range:[0,10,0] type:#float scale:0.01 fieldwidth:40 across:2 offset:[90,0] enabled:false
	spinner sm_max_expl_delay range:[0,10,0] type:#float scale:0.01 fieldwidth:40 enabled:false
	spinner sm_expl_offset_x "explosion offset XYZ:" range:[-9999,9999,0] type:#float scale:0.01 fieldwidth:40 across:3 offset:[76,0] enabled:false
	spinner sm_expl_offset_y "" range:[-9999,9999,0.1] type:#float scale:0.01 fieldwidth:40  offset:[38,0] enabled:false
	spinner sm_expl_offset_z "" range:[-9999,9999,0] type:#float scale:0.01 fieldwidth:40  offset:[0,0] enabled:false
	spinner sm_min_expl_xfactor "min/max X factor:" range:[-9999,9999,0] type:#float scale:0.01 fieldwidth:40 across:2 offset:[90,0] enabled:false
	spinner sm_max_expl_xfactor range:[-9999,9999,0.1] type:#float scale:0.01 fieldwidth:40 enabled:false
	spinner sm_min_expl_yfactor "min/max Y factor:" range:[-9999,9999,0] type:#float scale:0.01 fieldwidth:40 across:2 offset:[90,0] enabled:false
	spinner sm_max_expl_yfactor range:[-9999,9999,0.1] type:#float scale:0.01 fieldwidth:40 enabled:false
	spinner sm_min_expl_zfactor "min/max Z factor:" range:[-9999,9999,0] type:#float scale:0.01 fieldwidth:40 across:2 offset:[90,0] enabled:false
	spinner sm_max_expl_zfactor range:[-9999,9999,0.1] type:#float scale:0.01 fieldwidth:40 enabled:false
	spinner sm_min_expl_framerate "min/max framerate:" range:[0,9999,8] type:#integer fieldwidth:40 across:2 offset:[90,0] enabled:false
	spinner sm_max_expl_framerate range:[0,9999,8] type:#integer fieldwidth:40 enabled:false
	spinner sm_min_expl_scalefactor "min/max framerate:" range:[0,9999,15] type:#float scale:0.01 fieldwidth:40 across:2 offset:[90,0] enabled:false
	spinner sm_max_expl_scalefactor range:[0,9999,15] type:#float scale:0.01 fieldwidth:40 enabled:false
	label sm_expl_rotmode_label "rotation mode:" across:2 align:#right offset:[0,3] enabled:false
	dropdownlist sm_expl_rotmode "" items:#("randomrotate","norotate") width:145 align:#right enabled:false
	
	button sm_expl_frameadd "Add frame" width:100 across:3 offset:[16,16] enabled:false
	listbox sm_expl_frames "number of frames:" items:#() align:#right width:145 offset:[64,0] enabled:false
	listbox sm_expl_frames_opac "opacity:" items:#() align:#right width:40 enabled:false readOnly:true
	button sm_expl_framedelete "Remove frame" width:100 across:3 offset:[16,-115] enabled:false
	spinner sm_expl_frameopac "opacity:" range:[0,100,75] type:#integer fieldwidth:30 offset:[-90,-85] enabled:false
	
	on sm_explosions open do
	(
		global sm_explosions_ui = #(sm_explosions,sm_cur_expl,sm_min_explosions,sm_max_explosions,sm_min_expl_delay,sm_max_expl_delay,sm_expl_offset_x,sm_expl_offset_y,sm_expl_offset_z,sm_min_expl_xfactor,sm_max_expl_xfactor,sm_min_expl_yfactor,sm_max_expl_yfactor,sm_min_expl_zfactor,sm_max_expl_zfactor,sm_min_expl_framerate,sm_max_expl_framerate,sm_min_expl_scalefactor,sm_max_expl_scalefactor,sm_expl_rotmode_label,sm_expl_rotmode,sm_expl_frameadd,sm_expl_frames,sm_expl_frames_opac,sm_expl_framedelete,sm_expl_frameopac)
		global sm_explosions_variables = #(sm_min_explosions,sm_max_explosions,sm_min_expl_delay,sm_max_expl_delay,sm_expl_offset_x,sm_expl_offset_y,sm_expl_offset_z,sm_min_expl_xfactor,sm_max_expl_xfactor,sm_min_expl_yfactor,sm_max_expl_yfactor,sm_min_expl_zfactor,sm_max_expl_zfactor,sm_min_expl_framerate,sm_max_expl_framerate,sm_min_expl_scalefactor,sm_max_expl_scalefactor,sm_expl_rotmode,"")
		global sm_explosion_framevariables = #(sm_expl_frames,sm_expl_frames_opac)
		global cur_expl = 1
	)
	
	on sm_explosions changed val do
	(
		updateexplosion val sm_cur_expl.value
	)
	
	on sm_cur_expl changed val do
	(
		global cur_expl = val
		updateexplosion sm_explosions.value val
	)
	on sm_min_explosions changed i do conn_lvls[cur_conn][3][cur_expl][1] = i
	on sm_max_explosions changed i do conn_lvls[cur_conn][3][cur_expl][2] = i
	on sm_min_expl_delay changed i do conn_lvls[cur_conn][3][cur_expl][3] = i
	on sm_max_expl_delay changed i do conn_lvls[cur_conn][3][cur_expl][4] = i
	on sm_expl_offset_x changed i do conn_lvls[cur_conn][3][cur_expl][5] = i
	on sm_expl_offset_y changed i do conn_lvls[cur_conn][3][cur_expl][6] = i
	on sm_expl_offset_z changed i do conn_lvls[cur_conn][3][cur_expl][7] = i
	on sm_min_expl_xfactor changed i do conn_lvls[cur_conn][3][cur_expl][8] = i
	on sm_max_expl_xfactor changed i do conn_lvls[cur_conn][3][cur_expl][9] = i
	on sm_min_expl_yfactor changed i do conn_lvls[cur_conn][3][cur_expl][10] = i
	on sm_max_expl_yfactor changed i do conn_lvls[cur_conn][3][cur_expl][11] = i
	on sm_min_expl_zfactor changed i do conn_lvls[cur_conn][3][cur_expl][12] = i
	on sm_max_expl_zfactor changed i do conn_lvls[cur_conn][3][cur_expl][13] = i
	on sm_min_expl_framerate changed i do conn_lvls[cur_conn][3][cur_expl][14] = i
	on sm_max_expl_framerate changed i do conn_lvls[cur_conn][3][cur_expl][15] = i
	on sm_min_expl_scalefactor changed i do conn_lvls[cur_conn][3][cur_expl][16] = i
	on sm_max_expl_scalefactor changed i do conn_lvls[cur_conn][3][cur_expl][17] = i
	on sm_expl_rotmode selected i do  conn_lvls[cur_conn][3][cur_expl][18] = i
	
	on sm_expl_frameadd pressed do
	(
		frame = #()
		frames = sm_expl_frames.items
		opacities = sm_expl_frames_opac.items
		newframe = getOpenFileName()
		if newframe != undefined do
		(
			newframe = (getfilenamefile newframe)
		)
		frame[1] = newframe
		frame[2] = sm_expl_frameopac.value
		append conn_lvls[cur_conn][3][cur_expl][19] frame
		frames = append frames newframe
		opacities = append opacities (sm_expl_frameopac.value as string)
		sm_expl_frames.items = frames
		sm_expl_frames_opac.items = opacities
	)
	on sm_expl_framedelete pressed do
	(
		frames = sm_expl_frames.items
		opacities = sm_expl_frames_opac.items
		index = sm_expl_frames.selection
		deleteitem frames index
		deleteitem opacities index
		deleteitem conn_lvls[cur_conn][3][cur_expl][19] index
		sm_expl_frames.items = frames
		sm_expl_frames_opac.items = opacities
	)
	on sm_expl_frameopac changed val do
	(
		opacities = sm_expl_frames_opac.items
		opacities[sm_expl_frames.selection] = (val as string)
		conn_lvls[cur_conn][3][cur_expl][19][sm_expl_frames.selection][2] = val
		sm_expl_frames_opac.items = opacities
	)
)

rollout sm_slicks "Slicks materials:"
(
	label sm_slick_material_label "pick a slick material:" align:#right offset:[0,3] across:2
	button sm_slick_material "undefined" width:145 align:#right tooltip:"pick a slick! rightclick to remove"
	spinner sm_slick_x "unknown values XYZ:" range:[0,100,100] type:#integer fieldwidth:40 across:3 offset:[76,0] enabled:false
	spinner sm_slick_y "" range:[0,100,100] type:#integer fieldwidth:40  offset:[38,0] enabled:false
	spinner sm_slick_z "" range:[0,100,100] type:#integer fieldwidth:40  offset:[0,0] enabled:false
	spinner sm_slick_width "width, height, length:" range:[0,9999,0.2] type:#float scale:0.01 fieldwidth:40 across:3 offset:[76,0] enabled:false
	spinner sm_slick_height "" range:[0,9999,0.2] type:#float scale:0.01 fieldwidth:40  offset:[38,0] enabled:false
	spinner sm_slick_length "" range:[0,9999,0.2] type:#float scale:0.01 fieldwidth:40  offset:[0,0] enabled:false
	spinner sm_slick_min_skidduration "min/max skidmark duration:" range:[0,9999,20] type:#float scale:0.01 fieldwidth:40 across:2 offset:[90,0] enabled:false
	spinner sm_slick_max_skidduration range:[0,9999,20] type:#float scale:0.01 fieldwidth:40 enabled:false
	spinner sm_slick_min_skidfriction "min/max skid friction:" range:[0,9999,0.6] type:#float scale:0.01 fieldwidth:40 across:2 offset:[90,0] enabled:false
	spinner sm_slick_max_skidfriction range:[0,9999,0.6] type:#float scale:0.01 fieldwidth:40 enabled:false
	listbox sm_slick_skidmaterial "skid mark material:" items:#("SKIDMARK.MAT","DESKID.MAT","GIBSMEAR.MAT","MUD1.MAT","OILSMEAR.MAT","SNOWSKID.MAT")
	
	on sm_slicks open do
	(
		global sm_slicks_ui = #(sm_slick_x,sm_slick_y,sm_slick_z,sm_slick_width,sm_slick_height,sm_slick_length,sm_slick_min_skidduration,sm_slick_max_skidduration,sm_slick_min_skidfriction,sm_slick_max_skidfriction,sm_slick_skidmaterial)
		global sm_slicks_variables = #(sm_slick_material,sm_slick_x,sm_slick_y,sm_slick_z,sm_slick_width,sm_slick_height,sm_slick_length,sm_slick_min_skidduration,sm_slick_max_skidduration,sm_slick_min_skidfriction,sm_slick_max_skidfriction,sm_slick_skidmaterial)
		updateslicks conn_lvls[cur_conn][4]
	)
	on sm_slick_material pressed do
	(
		slickmaterial = getOpenFileName()
		if slickmaterial != undefined do
		(
			slickmaterial = (filenameFromPath slickmaterial)
		)
		if conn_lvls[cur_conn][4] == undefined do conn_lvls[cur_conn][4] = deepcopy smash_tab_slick
		conn_lvls[cur_conn][4][1] = slickmaterial
		updateslicks conn_lvls[cur_conn][4]
	)
	on sm_slick_material rightclick do
	(
		sm_slick_material.text = "undefined"
		conn_lvls[cur_conn][4] = undefined
		updateslicks conn_lvls[cur_conn][4]
	)
	on sm_slick_x changed i do conn_lvls[cur_conn][4][2] = i
	on sm_slick_y changed i do conn_lvls[cur_conn][4][3] = i
	on sm_slick_z changed i do conn_lvls[cur_conn][4][4] = i
	on sm_slick_width changed i do conn_lvls[cur_conn][4][5] = i
	on sm_slick_height changed i do conn_lvls[cur_conn][4][6] = i
	on sm_slick_length changed i do conn_lvls[cur_conn][4][7] = i
	on sm_slick_min_skidduration changed i do conn_lvls[cur_conn][4][8] = i
	on sm_slick_max_skidduration changed i do conn_lvls[cur_conn][4][9] = i
	on sm_slick_min_skidfriction changed i do conn_lvls[cur_conn][4][10] = i
	on sm_slick_max_skidfriction changed i do conn_lvls[cur_conn][4][11] = i
	on sm_slick_skidmaterial selected i do conn_lvls[cur_conn][4][12] = i
)

rollout sm_noncars "Activated noncars:"
(
	spinner sm_noncars_count "number of noncars:" range:[0,9,0] type:#integer fieldwidth:40 offset:[0,3]
	spinner sm_current_noncar "current edit noncar:" range:[1,1,1] type:#integer fieldwidth:40 offset:[0,3]
	
	spinner sm_min_noncar_delay "min/max start delay:" range:[0,10,0] type:#float scale:0.01 fieldwidth:40 across:2 offset:[90,0] enabled:false
	spinner sm_max_noncar_delay range:[0,10,0] type:#float scale:0.01 fieldwidth:40 enabled:false
	label sm_noncar_activation_label "activation box position:" across:2 align:#right offset:[0,3] enabled:false
	dropdownlist sm_noncar_activation "" items:#("absolute","relative") width:145 align:#right enabled:false
	spinner sm_noncar_index "noncar index (-1 is any):" range:[-1,99,-1] type:#integer fieldwidth:40 enabled:false
	spinner sm_noncar_min_x "1st activation area corner:" range:[-9999,9999,-10] type:#float scale:0.01 fieldwidth:40 across:3 offset:[76,0] enabled:false
	spinner sm_noncar_min_y "" range:[-9999,9999,-10] type:#float scale:0.01 fieldwidth:40  offset:[38,0] enabled:false
	spinner sm_noncar_min_z "" range:[-9999,9999,-10] type:#float scale:0.01 fieldwidth:40  offset:[0,0] enabled:false
	spinner sm_noncar_max_x "2nd activation area corner:" range:[-9999,9999,10] type:#float scale:0.01 fieldwidth:40 across:3 offset:[76,0] enabled:false
	spinner sm_noncar_max_y "" range:[-9999,9999,10] type:#float scale:0.01 fieldwidth:40  offset:[38,0] enabled:false
	spinner sm_noncar_max_z "" range:[-9999,9999,10] type:#float scale:0.01 fieldwidth:40  offset:[0,0] enabled:false
	spinner sm_noncar_min_tocar "min/max speed towards car:" range:[0,10,0] type:#float scale:0.01 fieldwidth:40 across:2 offset:[90,0] enabled:false
	spinner sm_noncar_max_tocar range:[0,10,0] type:#float scale:0.01 fieldwidth:40 enabled:false
	spinner sm_noncar_imp_velo "impact velocity factor:" range:[0,10,0] type:#float scale:0.01 fieldwidth:40 align:#right enabled:false
	spinner sm_noncar_rand_velo "random velocity:" range:[0,10,0] type:#float scale:0.01 fieldwidth:40 align:#right enabled:false
	spinner sm_noncar_randup_velo "random up velocity:" range:[0,10,0] type:#float scale:0.01 fieldwidth:40 align:#right enabled:false
	spinner sm_noncar_norm_velo "random normal velocity:" range:[0,10,0] type:#float scale:0.01 fieldwidth:40 align:#right enabled:false
	spinner sm_noncar_spinrate "random spin rate:" range:[0,999999,0] type:#integer fieldwidth:40 align:#right enabled:false
	
	on sm_noncars open do
	(
		global sm_noncars_ui = #(sm_noncars_count,sm_current_noncar,sm_min_noncar_delay,sm_max_noncar_delay,sm_noncar_activation_label,sm_noncar_activation,sm_noncar_index,sm_noncar_min_x,sm_noncar_min_y,sm_noncar_min_z,sm_noncar_max_x,sm_noncar_max_y,sm_noncar_max_z,sm_noncar_min_tocar,sm_noncar_max_tocar,sm_noncar_imp_velo,sm_noncar_rand_velo,sm_noncar_randup_velo,sm_noncar_norm_velo,sm_noncar_spinrate)
		global sm_noncars_variables = #(sm_min_noncar_delay,sm_max_noncar_delay,sm_noncar_activation,sm_noncar_index,sm_noncar_min_x,sm_noncar_min_y,sm_noncar_min_z,sm_noncar_max_x,sm_noncar_max_y,sm_noncar_max_z,sm_noncar_min_tocar,sm_noncar_max_tocar,sm_noncar_imp_velo,sm_noncar_rand_velo,sm_noncar_randup_velo,sm_noncar_norm_velo,sm_noncar_spinrate)
		global cur_nonc = 1
	)
	
	on sm_noncars_count changed val do
	(
		updatenoncars val sm_current_noncar.value
	)
	
	on sm_current_noncar changed val do
	(
		global cur_nonc = val
		updatenoncars sm_noncars_count.value val
	)
	on sm_min_noncar_delay changed val do conn_lvls[cur_conn][5][cur_nonc][1] = val
	on sm_max_noncar_delay changed val do conn_lvls[cur_conn][5][cur_nonc][2] = val
	on sm_noncar_activation selected val do conn_lvls[cur_conn][5][cur_nonc][3] = val
	on sm_noncar_index changed val do conn_lvls[cur_conn][5][cur_nonc][4] = val
	on sm_noncar_min_x changed val do conn_lvls[cur_conn][5][cur_nonc][5] = val
	on sm_noncar_min_y changed val do conn_lvls[cur_conn][5][cur_nonc][6] = val
	on sm_noncar_min_z changed val do conn_lvls[cur_conn][5][cur_nonc][7] = val
	on sm_noncar_max_x changed val do conn_lvls[cur_conn][5][cur_nonc][8] = val
	on sm_noncar_max_y changed val do conn_lvls[cur_conn][5][cur_nonc][9] = val
	on sm_noncar_max_z changed val do conn_lvls[cur_conn][5][cur_nonc][10] = val
	on sm_noncar_min_tocar changed val do conn_lvls[cur_conn][5][cur_nonc][11] = val
	on sm_noncar_max_tocar changed val do conn_lvls[cur_conn][5][cur_nonc][12] = val
	on sm_noncar_imp_velo changed val do conn_lvls[cur_conn][5][cur_nonc][13] = val
	on sm_noncar_rand_velo changed val do conn_lvls[cur_conn][5][cur_nonc][14] = val
	on sm_noncar_randup_velo changed val do conn_lvls[cur_conn][5][cur_nonc][15] = val
	on sm_noncar_norm_velo changed val do conn_lvls[cur_conn][5][cur_nonc][16] = val
	on sm_noncar_spinrate changed val do conn_lvls[cur_conn][5][cur_nonc][17] = val
)

rollout sm_sideeffect "Side effect smashes:"
(
	spinner sm_seffects_count "number of side effect smashes:" range:[0,9,0] type:#integer fieldwidth:40 offset:[0,3]
	spinner sm_current_seffect "current edit side effect:" range:[1,1,1] type:#integer fieldwidth:40 offset:[0,3]
	
	spinner sm_min_seffect_delay "min/max start delay:" range:[0,10,1] type:#float scale:0.01 fieldwidth:40 across:2 offset:[90,0] enabled:false
	spinner sm_max_seffect_delay range:[0,10,1] type:#float scale:0.01 fieldwidth:40 enabled:false
	label sm_seffect_label "*.DAT" align:#right
	label sm_seffect_activation_label "activation box position:" across:2 align:#right offset:[0,3] enabled:false
	dropdownlist sm_seffect_activation "" items:#("absolute","relative") width:145 align:#right enabled:false
	spinner sm_seffect_min_x "1st activation area corner:" range:[-9999,9999,-1.5] type:#float scale:0.01 fieldwidth:40 across:3 offset:[76,0] enabled:false
	spinner sm_seffect_min_y "" range:[-9999,9999,-1.5] type:#float scale:0.01 fieldwidth:40  offset:[38,0] enabled:false
	spinner sm_seffect_min_z "" range:[-9999,9999,-1.5] type:#float scale:0.01 fieldwidth:40  offset:[0,0] enabled:false
	spinner sm_seffect_max_x "2nd activation area corner:" range:[-9999,9999,1.5] type:#float scale:0.01 fieldwidth:40 across:3 offset:[76,0] enabled:false
	spinner sm_seffect_max_y "" range:[-9999,9999,1.5] type:#float scale:0.01 fieldwidth:40  offset:[38,0] enabled:false
	spinner sm_seffect_max_z "" range:[-9999,9999,1.5] type:#float scale:0.01 fieldwidth:40  offset:[0,0] enabled:false
	label sm_seffect_direction_label "activation direction:" across:2 align:#right offset:[0,3] enabled:false
	dropdownlist sm_seffect_direction "" items:#("toward","away") width:145 align:#right enabled:false selection:2
	spinner sm_seffect_force "created force:" range:[0,9999,4.4] range:[0,0,0] type:#float scale:0.01 fieldwidth:40 offset:[0,3] enabled:false
	
	on sm_sideeffect open do
	(
		global sm_sideeffect_ui = #(sm_seffects_count,sm_current_seffect,sm_min_seffect_delay,sm_max_seffect_delay,sm_seffect_label,sm_seffect_activation_label,sm_seffect_activation,sm_seffect_min_x,sm_seffect_min_y,sm_seffect_min_z,sm_seffect_max_x,sm_seffect_max_y,sm_seffect_max_z,sm_seffect_direction_label,sm_seffect_direction,sm_seffect_force)
		global sm_sideeffect_variables = #(sm_min_seffect_delay,sm_max_seffect_delay,"",sm_seffect_activation,sm_seffect_min_x,sm_seffect_min_y,sm_seffect_min_z,sm_seffect_max_x,sm_seffect_max_y,sm_seffect_max_z,sm_seffect_direction,sm_seffect_force)
		global cur_seff = 1
	)
	on sm_seffects_count changed val do
	(
		updatesideeffect val sm_current_seffect.value
	)
	on sm_current_seffect changed val do
	(
		global cur_seff = val
		updatesideeffect sm_seffects_count.value val
	)
	on sm_min_seffect_delay changed val do conn_lvls[cur_conn][6][cur_seff][1] = val
	on sm_max_seffect_delay changed val do conn_lvls[cur_conn][6][cur_seff][2] = val
	on sm_seffect_activation selected val do conn_lvls[cur_conn][6][cur_seff][4] = val
	on sm_seffect_min_x changed val do conn_lvls[cur_conn][6][cur_seff][5] = val
	on sm_seffect_min_y changed val do conn_lvls[cur_conn][6][cur_seff][6] = val
	on sm_seffect_min_z changed val do conn_lvls[cur_conn][6][cur_seff][7] = val
	on sm_seffect_max_x changed val do conn_lvls[cur_conn][6][cur_seff][8] = val
	on sm_seffect_max_y changed val do conn_lvls[cur_conn][6][cur_seff][9] = val
	on sm_seffect_max_z changed val do conn_lvls[cur_conn][6][cur_seff][10] = val
	on sm_seffect_direction selected val do conn_lvls[cur_conn][6][cur_seff][11] = val
	on sm_seffect_force changed val do conn_lvls[cur_conn][6][cur_seff][12] = val
)

rollout sm_extensions "Extensions:"
(
	spinner sm_extensionflag "extensionflag:" range:[0,1,0] type:#integer fieldwidth:40 enabled:false
	spinner sm_roomturnoncode "powerup given [data/powerup.txt]:" range:[0,99,0] type:#integer fieldwidth:40
	group "award codes"
	(
		label sm_awardcode_trigger_label "award code handling:" across:2 align:#right offset:[0,3] enabled:true
		dropdownlist sm_awardcode_trigger "" items:#("none","singleshot","repeated","doitregardless") width:145 align:#right enabled:true
		spinner sm_awardcode_credits "credits:" range:[0,9999,4500] type:#integer fieldwidth:40 offset:[0,3] enabled:false
		spinner sm_awardcode_timebonus "time bonus in seconds:" range:[0,9999,30] type:#integer fieldwidth:40 offset:[0,3] enabled:false
		spinner sm_awardcode_message "txt message [data/text.txt]:" range:[0,9999,1] type:#integer fieldwidth:40 offset:[0,3] enabled:false
		spinner sm_awardcode_scroller "scroller message [data/scrollers.txt]:" range:[0,9999,1] type:#integer fieldwidth:40 offset:[0,3] enabled:false
	)
	label sm_extensions_label1 ""
	group "run time variable changes (for missions)"
	(
		spinner sm_runvar_count "number of runtime variable changes:" range:[0,9,0] type:#integer fieldwidth:40 enabled:true
		spinner sm_current_runvar "current edit variable changes:" range:[1,1,1] type:#integer fieldwidth:40 enabled:false
		spinner sm_min_runvar "min/max var change:" range:[0,10,0] type:#integer fieldwidth:40 across:2 offset:[90,0] enabled:false
		spinner sm_max_runvar range:[0,10,0] type:#integer fieldwidth:40 enabled:false
	)
	on sm_extensions open do
	(
		global sm_awardcode_ui = #(sm_awardcode_trigger,sm_awardcode_credits,sm_awardcode_timebonus,sm_awardcode_message,sm_awardcode_scroller)
		global sm_runvar_ui = #(sm_runvar_count,sm_current_runvar,sm_min_runvar,sm_max_runvar)
		global cur_runvar = 1
	)
	on sm_awardcode_trigger selected i do
	(
		updateawardcode i
	)
	on sm_awardcode_credits changed val do conn_lvls[cur_conn][9][2] = val
	on sm_awardcode_timebonus changed val do conn_lvls[cur_conn][9][3] = val
	on sm_awardcode_message changed val do conn_lvls[cur_conn][9][4] = val
	on sm_awardcode_scroller changed val do conn_lvls[cur_conn][9][5] = val
	
	on sm_runvar_count changed val do
	(
		updaterunvar val cur_runvar
	)
	on sm_current_runvar changed val do
	(
		global cur_runvar = val
		updaterunvar sm_runvar_count.value val
	)
	on sm_min_runvar changed val do conn_lvls[cur_conn][10][cur_runvar][1] = val
	on sm_max_runvar changed val do conn_lvls[cur_conn][10][cur_runvar][2] = val
)

updateconnotations 1

createdialog smashable_setup 360 700 0 0
smashable_setup.sm_sub.height += 500