global instances = #()
global statics = #()
global numcollumns = 4
global processtree = #()


for object in objects do
(
	if object.ishidden == false do
	(
		if object.name[1] == "&" then
		(
			append instances object
		)
		else
		(
			append statics object
		)
	)
)
if statics[1] != undefined do
(
	setCommandPanelTaskMode #create
	convertto statics[1] editable_poly
	for i=2 to statics.count do
	(
		statics[1].EditablePoly.attach statics[i] statics[1]
	)
	global trackstatic = statics[1]
	global trackwidth = trackstatic.max.x - trackstatic.min.x
	global tracklength = trackstatic.max.y - trackstatic.min.y
	global segmentwidth = trackwidth / numcollumns
	global segmentlength = tracklength / numcollumns

	for i = 1 to (numcollumns-1) do --make width slices
	(
		Slice = Slicemodifier()
		addmodifier trackstatic Slice
		slice.slice_type = 1
		Slice.slice_plane.position = [0,0,(trackstatic.min.x + (segmentwidth * i))]
		slice.slice_plane.rotation = (quat 0 1 0 1)
		convertto trackstatic editable_poly
	)
	for i = 1 to (numcollumns-1) do --make length slices
	(
		Slice = Slicemodifier()
		addmodifier trackstatic Slice
		slice.slice_type = 1
		Slice.slice_plane.position = [0,0,(trackstatic.min.y + (segmentlength * i))]
		slice.slice_plane.rotation = (quat 1 0 0 1)
		convertto trackstatic editable_poly
	)
	
	for i=1 to (numcollumns * numcollumns) do
	(
		processtree[i]
		for object in objects do
		(
			position = object.pos
			treechild = #()
			global minx = (objects.min.x+((i-1)*segmentwidth))
			global maxx = (objects.min.x+((i)*segmentwidth))
			global miny = (object.min.y+((i-1)*segmentlength))
			global maxy = (object.min.y+((i)*segmentlength))
			
			if minx<object.pos.x and object.pos.x<maxx and miny<object.pos.y and object.pos.y<maxy do
			(
				append treechild object
			)
			processtree[i]=treechild
		)
	)
	
)
