
--first we create arrays to index all our objects into cathegories
global index_startinggrid = #()
global mp_startingpoints = #()
global checkpoints = #()
global env_boxes = #()
global grooves = #()
global pedspec_materials = #()
global Funk_materials = #()
global dronenodes = #()
global opp_paths = #()
global noncar_models = #()
global smashables = #()

fn writeconnotations conn txt_file = 
(
	if conn != undefined do
	(
		format "	%	// number of possible sounds\n" conn[1].count to:txt_file
		if conn[1].count > 0 do
		(
			for i=1 to conn[1].count do
			(
				format "		%	// sound id %\n" conn[1][i] i to:txt_file
			)
		)
		format "	%	// number of shrapnels\n" conn[2].count to:txt_file
		if conn[2].count > 0 do
		(
			for i=1 to conn[2].count do
			(
				shrapnel = conn[2][i]
				shrapnel_types = #("shards","noncars","ghostparts")
				format "		%	// shrapnel type\n" shrapnel_types[(shrapnel[1])] to:txt_file
				format "		%,%	// min/max toward you speed\n" shrapnel[2] shrapnel[3] to:txt_file
				format "		%	// impact velocity factor\n" shrapnel[4] to:txt_file
				format "		%	// random velocity\n" shrapnel[5] to:txt_file
				format "		%	// random up velocity\n" shrapnel[6] to:txt_file
				format "		%	// random normal velocity\n" shrapnel[7] to:txt_file
				format "		%	// random spin rate\n" shrapnel[8] to:txt_file
				if shrapnel[1] == 1 do
				(
					format "		%,%	// min/max time before vanishing\n" shrapnel[9] shrapnel[10] to:txt_file
					format "		%	// min cut length\n" shrapnel[11] to:txt_file
					format "		%	// flags\n" shrapnel[12] to:txt_file
					format "		%	// shrapnel mat file\n" shrapnel[13] to:txt_file
				)
				if shrapnel[1] == 2 do
				(
					shrapnel_placements = #("actorbased","sphereclumped","boxclumped")
					format "		%	// shrapnel placement\n" shrapnel_placements[(shrapnel[14])] to:txt_file
					if shrapnel[14] == 2 do
					(
						format "		%	// sphere radius\n" shrapnel[15] to:txt_file
						clumping_centres = #("impact","model")
						format "		%	// clumping centre\n" clumping_centres[(shrapnel[18])] to:txt_file
					)
					if shrapnel[14] == 3 do
					(
						format "		%	// sphere length\n" shrapnel[16] to:txt_file
						format "		%	// sphere height\n" shrapnel[17] to:txt_file
						clumping_centres = #("impact","model")
						format "		%	// clumping centre\n" clumping_centres[(shrapnel[18])] to:txt_file
					)
						
					format "		%,%	// min/max bits to use\n" shrapnel[19] shrapnel[20] to:txt_file
					format "		%	// chance of fire/smoke\n" shrapnel[21] to:txt_file
					format "		%	// number of fire/smoke collumns\n" shrapnel[22] to:txt_file
					format "		%,%	// min/max smokeyness\n" shrapnel[23] shrapnel[24] to:txt_file
					format "		%	// shrapnel actor in tracks folder\n" shrapnel[25] to:txt_file
					format "		%	// number of seperate actors in file\n" shrapnel[26] to:txt_file
					format "		%	// actor name\n" shrapnel[27] to:txt_file
					format "		%	// noncar txt file to be used\n" shrapnel[28] to:txt_file
				)
				if shrapnel[1] == 3 do
				(
					shrapnel_placements = #("actorbased","sphereclumped","boxclumped")
					format "		%	// shrapnel placement\n" shrapnel_placements[(shrapnel[14])] to:txt_file
					if shrapnel[14] == 2 do
					(
						format "		%	// sphere radius\n" shrapnel[15] to:txt_file
						clumping_centres = #("impact","model")
						format "		%	// clumping centre\n" clumping_centres[(shrapnel[18])] to:txt_file
					)
					if shrapnel[14] == 3 do
					(
						format "		%	// sphere length\n" shrapnel[16] to:txt_file
						format "		%	// sphere height\n" shrapnel[17] to:txt_file
						clumping_centres = #("impact","model")
						format "		%	// clumping centre\n" clumping_centres[(shrapnel[18])] to:txt_file
					)
					format "		%,%	// min/max time before vanishing\n" shrapnel[9] shrapnel[10] to:txt_file
					format "		%	// min bits to use\n" shrapnel[19] to:txt_file
					format "		%	// min bits to use\n" shrapnel[20] to:txt_file
					format "		%	// shrapnel actor in tracks folder\n" shrapnel[25] to:txt_file
				)
			)
		)
		format "	%	// number of explosion groups\n" conn[3].count to:txt_file
		if conn[3].count > 0 do
		(
			for i=1 to conn[3].count do
			(
				global explosion = conn[3][i]
				format "		%,%	// min/max explosions clouds\n" explosion[1] explosion[2] to:txt_file
				format "		%,%	// min/max start delay\n" explosion[3] explosion[4] to:txt_file
				format "		%,%,%	// offset\n" explosion[5] explosion[6] explosion[7] to:txt_file
				format "		%,%	// min/max x factor\n" explosion[8] explosion[9] to:txt_file
				format "		%,%	// min/max y factor\n" explosion[10] explosion[11] to:txt_file
				format "		%,%	// min/max z factor\n" explosion[12] explosion[13] to:txt_file
				format "		%,%	// min/max frame rate\n" explosion[14] explosion[15] to:txt_file
				format "		%,%	// min/max scaling factor\n" explosion[16] explosion[17] to:txt_file
				rotation_modes = #("randomrotate","norotate")
				format "		%	// rotations mode\n" rotation_modes[(explosion[18])]  to:txt_file
				format "		%	// number of frames\n" explosion[19].count  to:txt_file
				for i =1 to explosion[19].count do
				(
					format "			%	// opacity\n" explosion[19][i][2] to:txt_file
					format "			%	// frame pix name\n" explosion[19][i][1]to:txt_file
				)
			)
		)
		if conn[4] == undefined then
		(
			format "	none	// slick material\n" to:txt_file
		)
		else
		(
			slick = conn[4]
			format "	%	// slick material\n" slick[1] to:txt_file
			format "		%,%,%	// ?\n" slick[2] slick[3] slick[4] to:txt_file
			format "		%,%,%	// width/height/length \n" slick[5] slick[6] slick[7] to:txt_file
			format "		%,%	// min/max skidmark duration\n" slick[8] slick[9] to:txt_file
			format "		%,%	// min/max skidmark friction\n" slick[10] slick[11] to:txt_file
			skidmark_materials = #("SKIDMARK.MAT","DESKID.MAT","GIBSMEAR.MAT","MUD1.MAT","OILSMEAR.MAT","SNOWSKID.MAT")
			format "		%	// skidmark material\n" skidmark_materials[(slick[12])] to:txt_file
		)
		format "	%	// number of noncar cuboids\n" conn[5].count to:txt_file
		if conn[5].count > 0 do
		(
			for i=1 to conn[5].count do
			(
				noncar = conn[5][i]
				format "		%,%	// min/max start delay\n" noncar[1] noncar[2] to:txt_file
				activation_positions = #("absolute","relative")
				format "		%	// activation position\n" activation_positions[(noncar[3])] to:txt_file
				format "		%	// index of noncar to be activated\n" noncar[4] to:txt_file
				format "		%,%,%	// 1st activation area corner\n" noncar[5] noncar[6] noncar[7] to:txt_file
				format "		%,%,%	// 2nd activation area corner\n" noncar[8] noncar[9] noncar[10] to:txt_file
				format "		%,%	// min/max toward you speed\n" noncar[11] noncar[12] to:txt_file
				format "		%	// impact velocity factor\n" noncar[13] to:txt_file
				format "		%	// random velocity\n" noncar[14] to:txt_file
				format "		%	// random up velocity\n" noncar[15] to:txt_file
				format "		%	// random normal velocity\n" noncar[16] to:txt_file
				format "		%	// random spin rate\n" noncar[17] to:txt_file
			)
		)
		format "	%	// side effect smashes\n" conn[6].count to:txt_file
		if conn[6].count > 0 do
		(
			for i=1 to conn[6].count do
			(
				sidesmash = conn[6][i]
				format "		%,%	// min/max start delay\n" sidesmash[1] sidesmash[2] to:txt_file
				format "		%	// ?\n" sidesmash[3] to:txt_file
				activation_positions = #("absolute","relative")
				format "		%	// activation position\n" activation_positions[(sidesmash[4])] to:txt_file
				format "		%,%,%	// 1st activation area corner\n" sidesmash[5] sidesmash[6] sidesmash[7] to:txt_file
				format "		%,%,%	// 2ndactivation area corner\n" sidesmash[8] sidesmash[9] sidesmash[10] to:txt_file
				activation_directions = #("away","toward")
				format "		%	// activation direction\n" activation_directions[(sidesmash[11])] to:txt_file
				format "		%	// created force\n" sidesmash[12] to:txt_file
			)
		)
		format "	%	// extension flags? \n" conn[7] to:txt_file
		format "	%	// powerups given \n" conn[8] to:txt_file
		if conn[9].count == 0 then
		(
			format "	none	// award code \n" to:txt_file
		)
		else 
		(
			awardcode = conn[9]
			handling = #("singleshot","repeated","doitregardless")
			format "	%	// award code \n" handling[(awardcode[1])] to:txt_file
			format "		%	// credits \n" awardcode[2] to:txt_file
			format "		%	// time bonus \n" awardcode[3] to:txt_file
			format "		%	// txt message \n" awardcode[4] to:txt_file
			format "		%	// scroller message \n" awardcode[5] to:txt_file
		)
		format "	%	// run time variable changes \n" conn[10].count to:txt_file
		if conn[10].count > 0 do
		(
			for i in conn[10] do
			(
				runvar = conn[10][i]
				format "		%,%	// min/max var changes \n" runvar[1] runvar[2] to:txt_file
			)
		)
	)
)

--indexing the objects into their cathegories, stored in the arrays
for object in objects do
(
	if custAttributes.get object checkpoint_CA != undefined do
	(
		append checkpoints object
	)
	if custAttributes.get object SEV_data_CA != undefined do
	(
		append env_boxes object
	)
	if custAttributes.get object Groove_data_CA != undefined do
	(
		append grooves object
	)
	if custAttributes.get object starting_grid_CA != undefined do
	(
		index_startinggrid[1] = object
	)
	if custAttributes.get object multiplayer_point_CA != undefined do
	(
		append mp_startingpoints object
	)
	try 
	(
		if custAttributes.get object smashable_CA != undefined do
		(
			append smashables object
		)
	)
	catch()
)
--indexing the materials into the material array
for material in scenematerials do
(
	for j=1 to (custAttributes.count material) do
	(
		if (custAttributes.get material j).name == "Pedspec_data" do
		(
			append pedspec_materials material
		)
		if (custAttributes.get material j).name == "Funk_data" do
		(
			append Funk_materials material
		)
	) 
)
--creating the export txt file. If not undefined continue the export. If undefined, quit the export
exportname = GetSaveFileName caption:"Choose an exportname" types:"Txt(*.txt)"
if exportname != undefined do
(
	txt_name = getfilenamefile exportname +  ".txt"
)
if txt_name != undefined then
(
	txt_file = createfile txt_name
	-- here follows the literal txt file text, all in order
	format "VERSION 1\n\n" to:txt_file
	--GLOBAL LIGHTING DATA
	format "%,%,%\n" 	(rootnode.track_general_attributes.main_directional_light_source.r as integer) \
								(rootnode.track_general_attributes.main_directional_light_source.g as integer) \
								(rootnode.track_general_attributes.main_directional_light_source.b as integer) to:txt_file
	format "%,%\n" (rootnode.track_general_attributes.ambient_ambient_0) (rootnode.track_general_attributes.ambient_diffuse_0) to:txt_file
	format "%,%\n" (rootnode.track_general_attributes.ambient_ambient_1) (rootnode.track_general_attributes.ambient_diffuse_1) to:txt_file
	format "%,%\n\n" (rootnode.track_general_attributes.ambient_ambient_2) (rootnode.track_general_attributes.ambient_diffuse_2) to:txt_file
	--STARTING GRID
	if index_startinggrid[1] != undefined do
	(
		format "%,%,%	//starting grid position\n%	//starting grid rotation\n\n" (round index_startinggrid[1].pos.x) (round index_startinggrid[1].pos.z) (round -index_startinggrid[1].pos.y) (index_startinggrid[1].rotation.z_rotation) to:txt_file
	)
	if index_startinggrid[1] == undefined do
	(
		format "0,0,0	//starting grid position\n0	//starting grid rotation\n\n" to:txt_file
	)
	--CHECKPOINTS
	if checkpoints.count != 0 then
	(
		format "%	//number of checkpoints\n\n" checkpoints.count to:txt_file
		for i = 1 to checkpoints.count do
		(
			pointcount = getnumverts (snapshotasmesh checkpoints[i])
			format "%,%,%\n\n1\n" checkpoints[i].checkpoint_attributes.checkpoint_bonus_1 checkpoints[i].checkpoint_attributes.checkpoint_bonus_2 checkpoints[i].checkpoint_attributes.checkpoint_bonus_3 to:txt_file
			pointindex1 = getvert (snapshotasmesh checkpoints[i]) 1
			pointindex2 = getvert (snapshotasmesh checkpoints[i]) 2
			pointindex3 = getvert (snapshotasmesh checkpoints[i]) 3
			pointindex4 = getvert (snapshotasmesh checkpoints[i]) 4
			format "% ,% ,% \n"  (round pointindex1.x) (round pointindex1.z) (round -pointindex1.y) to:txt_file
			format "% ,% ,% \n"  (round pointindex2.x) (round pointindex2.z) (round -pointindex2.y) to:txt_file
			format "% ,% ,% \n"  (round pointindex4.x) (round pointindex4.z) (round -pointindex4.y) to:txt_file
			format "% ,% ,% \n\n"  (round pointindex3.x) (round pointindex3.z) (round -pointindex3.y) to:txt_file
			
		)
	)
	else
	(
		format "0	//number of checkpoints\n\n" to:txt_file
	)
	format "%	// number of SMASHABLE ENVIRONMENT SPECS\n\n" smashables.count to:txt_file
	for i=1 to smashables.count do
	(
		smashable = smashables[i]
		global tab = (execute smashable.smashable_data.smashable_param)
		format "%	// Flags\n" tab[1] to:txt_file
		format "%	// Name of trigger &model\n" tab[2] to:txt_file
		if tab[3] == 1 do
		(
			format "Nochange	// Mode\n" to:txt_file
			format "0.005	// Removal threshold\n\n" to:txt_file
			nochange_conn = tab[4][1]
			writeconnotations nochange_conn txt_file
			
			format "\n" to:txt_file
			format "	0	// reserved 1 \n" to:txt_file
			format "	0	// reserved 2 \n" to:txt_file
			format "	0	// reserved 3 \n" to:txt_file
			format "	0	// reserved 4 \n" to:txt_file
		)
		if tab[3]==2 do
		(
			format "Replacemodel	// Mode\n" to:txt_file
			format "0.005	// Removal threshold\n\n" to:txt_file
			repl_mod = tab[4]
			repl_conn = repl_mod[1][1]
			writeconnotations repl_conn txt_file
					
			format "\n" to:txt_file
			format "%	// new model\n" repl_mod[2] to:txt_file
			format "%	// chance of fire/smoke\n" repl_mod[3] to:txt_file
			format "%	// number of fire/smoke collumns\n" repl_mod[4] to:txt_file
			format "%,%	// min/max smokeyness\n" repl_mod[5] repl_mod[6] to:txt_file
			
			format "\n" to:txt_file
			format "0	// reserved 1 \n" to:txt_file
			format "0	// reserved 2 \n" to:txt_file
			format "0	// reserved 3 \n" to:txt_file
			format "0	// reserved 4 \n" to:txt_file
			format "\n" to:txt_file
		)
		if tab[3]==3 do
		(
			format "Remove	// Mode\n" to:txt_file
			format "0.005	// Removal threshold\n\n" to:txt_file
			remove_conn = tab[4][1]
			writeconnotations remove_conn txt_file
			format "\n" to:txt_file
			format "	0	// reserved 1 \n" to:txt_file
			format "	0	// reserved 2 \n" to:txt_file
			format "	0	// reserved 3 \n" to:txt_file
			format "	0	// reserved 4 \n" to:txt_file
			format "\n" to:txt_file
		)
		if tab[3]==4 do
		(
			format "Texturechange	// Mode\n" to:txt_file
			txtr_chng = tab[4]
			format "%	// Intact pixelmap\n" txtr_chng[1] to:txt_file
			format "%	// Number of levels\n\n" (txtr_chng[2].count as string) to:txt_file
			for i=1 to txtr_chng[2].count do
			(
				txtr_lvl = txtr_chng[2][i]
				global txtr_conn = txtr_chng[3][i]
				format "%	// trigger threshhold\n" (txtr_lvl[1] as string) to:txt_file
				format "%	// flags\n" (txtr_lvl[2] as string) to:txt_file
				collision_types = #("solid","passthrough")
				format "%	// collision type\n\n" collision_types[(txtr_lvl[3])] to:txt_file
				writeconnotations txtr_conn txt_file
				format "\n" to:txt_file
				
				format "%	// number of pixelmaps\n" 1 to:txt_file
				format "%	// pixemap\n" txtr_chng[1] to:txt_file
				format "\n" to:txt_file
			)
			format "\n" to:txt_file
			format "0	// reserved 1 \n" to:txt_file
			format "0	// reserved 2 \n" to:txt_file
			format "0	// reserved 3 \n" to:txt_file
			format "0	// reserved 4 \n" to:txt_file
			format "\n" to:txt_file
		)
	)
	
	--PEDESTRIAN SETTINGS
	format "%	//number of Ped Spawn Materials\n\n" pedspec_materials.count to:txt_file
	for material in pedspec_materials do
	(
		format "%	//ped spawn material\n" material.name to:txt_file
		format "%	//movement index\n" material.pedspec_data.Pedspec_movement_index to:txt_file
		format "%	//group index\n" material.pedspec_data.Pedspec_group_index to:txt_file
		format "%	//density\n" material.pedspec_data.Pedspec_density to:txt_file
		format "%	//exclusion material 1\n" material.pedspec_data.Pedspec_exclusion1 to:txt_file
		format "%	//exclusion material 2\n\n" material.pedspec_data.Pedspec_exclusion2 to:txt_file
	)
	format "TRACKX.ACT	//additional actor\n\n" to:txt_file
	--Horizon and environment settings
	format "%		// Name of sky texture pixelmap\n" rootnode.track_general_attributes.horizon_bitmap_file to:txt_file
	format "%		// Horizontal repetitions of sky texture\n" rootnode.track_general_attributes.horizon_hor_repetitions to:txt_file
	format "%		// Vertical size of sky texture (degrees)\n" rootnode.track_general_attributes.horizon_ver_angle to:txt_file
	format "%		// Position of horizon (pixels below top)\n" rootnode.track_general_attributes.horizon_position to:txt_file to:txt_file
	if rootnode.track_general_attributes.horizon_depth_cue_mode == 1 do format "None		// Depth cue mode\n" to:txt_file
	if rootnode.track_general_attributes.horizon_depth_cue_mode == 2 do format "Dark		// Depth cue mode\n" to:txt_file
	if rootnode.track_general_attributes.horizon_depth_cue_mode == 3 do format "Fog		// Depth cue mode\n" to:txt_file
	if rootnode.track_general_attributes.horizon_depth_cue_mode == 4 do format "Colour		// Depth cue mode\n" to:txt_file
	format "%,%		// Degree of fog/darkness\n" rootnode.track_general_attributes.horizon_fognear  rootnode.track_general_attributes.horizon_fogfar to:txt_file
	format "%,%,%	// Depth cue colour (red, green, blue )\n\n" (rootnode.track_general_attributes.horizon_depth_cue_color.r as integer) (rootnode.track_general_attributes.horizon_depth_cue_color.g as integer) (rootnode.track_general_attributes.horizon_depth_cue_color.b as integer) to:txt_file
	--DEFAULT ENGINE NOISE
	format "0	//Default engine noise\n\n" to:txt_file
	--SPECIAL EFFECTS VOLUMES
	if env_boxes.count != 0 then
	(
		format "%	//number of special effects volumes\n\n" env_boxes.count to:txt_file
		for i = 1 to env_boxes.count do
		(
			currentbox = env_boxes[i]
			format "BOX			//%\n" currentbox.name to:txt_file
			format "%,0,0			//offset from center on X axis\n" (((currentbox.max.x * 2)-(currentbox.center.x * 2))/ 2) to:txt_file
			format "0,%,0			//offset from center on Y axis\n" (((currentbox.max.z * 2)-(currentbox.center.z * 2))/ 2) to:txt_file
			format "0,0,%			//offset from center on Z axis\n" (((currentbox.max.y * 2)-(currentbox.center.y * 2))/ 2) to:txt_file
			format "%,%,%	//center point of the box in the world\n" currentbox.pos.x currentbox.pos.z -currentbox.pos.y to:txt_file
			format "%			//gravity multiplier\n" currentbox.SEV_data.sev_gravity to:txt_file
			format "%			//viscosity multiplier\n" currentbox.SEV_data.sev_viscosity to:txt_file
			format "0.0			//car damage per millisecond\n0.0			//ped damage per millisecond\n" to:txt_file
			format "%			//camera effect\n" currentbox.SEV_data.SEV_cameffect to:txt_file
			format "%			//sky colour\n" currentbox.sev_data.sev_skycolor to:txt_file
			format "NONE			//windscreen texture to use (no effect)\n" to:txt_file
			format "%			//enter sound id\n" currentbox.sev_data.sev_entersnd to:txt_file
			format "%			//exit sound id\n" currentbox.sev_data.sev_exitsnd to:txt_file
			format "%			//engine sound index\n" currentbox.sev_data.sev_engsnd to:txt_file
			format "%			//material index\n" currentbox.sev_data.sev_materialindex to:txt_file
			if currentbox.sev_data.sev_soundtype_param == 1 do
			(
				format "None		//sound type\n" to:txt_file
			)
			if currentbox.sev_data.sev_soundtype_param != 1 do
			(
				if currentbox.sev_data.sev_soundtype_param == 2 do format "SCATTERED		//sound type\n" to:txt_file
				if currentbox.sev_data.sev_soundtype_param == 3 do format "SATURATED		//sound type\n" to:txt_file
				if currentbox.sev_data.sev_sounddelay_param ==1 do
				(
					format "Random			//sound delay\n" to:txt_file
					format "%,%			//min/max delay between sounds\n" currentbox.sev_data.SEV_minimumint currentbox.sev_data.SEV_maximumint to:txt_file
					for i = 1 to currentbox.sev_data.SEV_sounds_param.count do
					(
						format "%\n" currentbox.sev_data.SEV_sounds_param[i] to:txt_file
					)
				)
				if currentbox.sev_data.sev_sounddelay_param ==2 do
				(
					format "Continuous			//sound delay\n" to:txt_file
					format "%\n" currentbox.sev_data.SEV_sounds_param[i] to:txt_file
				)
			)
			format "\n" to:txt_file
		)
	)
	else 
	(
		format "0	//number of special effects volumes\n\n" to:txt_file
	)
	--SOUND GENERATORS
	format "0	//Number of sound generators\n\n" to:txt_file
	--REFLECTIVE WINDSCREEN SPECIFICATIONS
	format "DRKSCRN.MAT	// Material to use for default screens\nDRKSCRN.MAT	// Material to use for default screens during darkness\nFOGSCRN.MAT	// Material to use for default screens during fog\n0	// (ignore) # areas with different screens\n\n" to:txt_file
	--MAP DETAILS
	if rootnode.track_general_attributes.minimapbitmap != "none" do
	(
		format "%			//minimap filename \n"  (getfilenamefile rootnode.track_general_attributes.minimapbitmap) to:txt_file
		minimaptm = rootnode.track_general_attributes.minimaptm
		format "%,%,%\n" (round minimaptm.row1.x) (round minimaptm.row1.y) (round minimaptm.row1.z)  to:txt_file
		format "%,%,%\n" (round minimaptm.row2.x) (round minimaptm.row2.y) (round minimaptm.row2.z)  to:txt_file
		format "%,%,%\n" (round minimaptm.row3.x) (round minimaptm.row3.y) (round minimaptm.row3.z)  to:txt_file
		format "%,%,%\n\n" (round minimaptm.row4.x) (round minimaptm.row4.y) (round minimaptm.row4.z)  to:txt_file
	)
	if rootnode.track_general_attributes.minimapbitmap == "none" do
	(
		format "%			//minimap filename \n" (getfilenamefile exportname) to:txt_file
		format "0,0,0\n0,0,0\n0,0,0\n0,0,0\n\n" image_ratio to:txt_file
	)
	--FUNK MATERIALS
	format "START OF FUNK\n\n" to:txt_file
	for material in funk_materials do
	(
		format "%  		//Material name\n" material.name to:txt_file
		funk_distance_strings = #("DISTANT", "CONSTANT","LASTLAP","OTHERLAPS")
		format "%  		//distance\n" funk_distance_strings[material.funk_data.funk_distance_param] to:txt_file
		funk_animation_strings = #("PISS OFF", "ROLL", "SLITHER", "THROB")
		format "%  		//animation\n" funk_animation_strings[material.funk_data.funk_animation_param] to:txt_file
		funk_animation_mode_strings = #("HARMONIC", "LINEAR", "CONTINUOUS")
		format "%  		//animation mode\n" funk_animation_mode_strings[material.funk_data.funk_animation_mode_param] to:txt_file
		if material.funk_data.funk_animation_param != 1 do
		(
			format "%,%  		//animation speed\n" material.funk_data.funk_animation_speed_x material.funk_data.funk_animation_speed_y to:txt_file
		)
		if material.funk_data.funk_animation_param == 3 do
		(
			format "%,%  		//animation extent\n" material.funk_data.funk_animation_extent_x material.funk_data.funk_animation_extent_y to:txt_file
		)
		if material.funk_data.funk_animation_param == 4 do
		(
			format "%,%  		//animation extent\n" material.funk_data.funk_animation_extent_x material.funk_data.funk_animation_extent_y to:txt_file
			format "%,%  		//animation centre\n" material.funk_data.funk_animation_centre_x material.funk_data.funk_animation_centre_y to:txt_file
		)
		format "NO FUCKING LIGHTING\n" to:txt_file
		funk_sequence_strings = #("NONE","FRAMES")
		format "%  		//sequence\n" funk_sequence_strings[material.funk_data.funk_sequence_param] to:txt_file
		if material.funk_data.funk_sequence_param == 2 do
		(
			funk_playback_strings = #("APPROXIMATE","ACCURATE")
			format "%  		//playback\n" funk_playback_strings[material.funk_data.funk_playback_param] to:txt_file
			funk_sequence_type_stings = #("CONTINUOUS","LINEAR","HARMONIC","FLASH")
			format "%  		//sequence type\n" funk_sequence_type_stings[material.funk_data.funk_sequence_type_param] to:txt_file
			format "%\n" material.funk_data.funk_sequence_frame_names_param to:txt_file
		)
		format "\n" to:txt_file
		if funk_materials.count > 1 do
		(
			format "NEXT FUNK\n\n" to:txt_file
		)
	)
	format "END OF FUNK\n\n" to:txt_file
	--GROOVE OBJECTS
	format "START OF GROOVE\n\n" to:txt_file
	if grooves.count != 0 do
	(
		for i=1 to grooves.count do
		(
			format "%\n" (grooves[i].name) to:txt_file
			if grooves[i].groove_data.groove_lollipop_param == 1 do format  "None\n" to:txt_file
			if grooves[i].groove_data.groove_lollipop_param == 2 do format  "Xlollipop\n" to:txt_file
			if grooves[i].groove_data.groove_lollipop_param == 3 do format  "Ylollipop\n" to:txt_file
			if grooves[i].groove_data.groove_lollipop_param == 4 do format  "Zlollipop\n" to:txt_file
			
			if grooves[i].groove_data.groove_distance_param == 1 do format "Distance\n" to:txt_file
			if grooves[i].groove_data.groove_distance_param == 2 do format "Constant\n" to:txt_file
				
			if grooves[i].groove_data.groove_path_type_param == 1 do format  "No path\n" to:txt_file
			if grooves[i].groove_data.groove_path_type_param == 2 do
			(
				format "Straight\n" to:txt_file
				path_modes = #("Linear", "Harmonic", "Flash")
				format "%\n" path_modes[grooves[i].groove_data.groove_path_mode_param] to:txt_file
				format "%,%,%\n" grooves[i].groove_data.groove_path_center_X_param grooves[i].groove_data.groove_path_center_Z_param -grooves[i].groove_data.groove_path_center_Y_param to:txt_file
				format "%\n" grooves[i].groove_data.groove_path_speed_param to:txt_file
				format "%,%,%\n" grooves[i].groove_data.groove_path_extent_X_param grooves[i].groove_data.groove_path_extent_Z_param -grooves[i].groove_data.groove_path_extent_Y_param to:txt_file
			)
			if grooves[i].groove_data.groove_path_type_param == 3 do
			(
				format "Circular\n" to:txt_file
				path_modes = #("Linear", "Harmonic", "Flash")
				format "%\n" path_modes[grooves[i].groove_data.groove_path_mode_param] to:txt_file
				format "%,%,%\n" grooves[i].groove_data.groove_path_center_X_param grooves[i].groove_data.groove_path_center_Z_param -grooves[i].groove_data.groove_path_center_Y_param to:txt_file
				format "%\n" grooves[i].groove_data.groove_path_speed_param to:txt_file
				format "%\n" grooves[i].groove_data.groove_path_radius_param to:txt_file
				format "%\n" grooves[i].groove_data.groove_path_axis_param to:txt_file
			)
			animation_types = #("None","Spin","Rock","Shear","Throb")
			animation_modes = #("Linear","Harmonic","Flash","Continuous")
			if grooves[i].groove_data.groove_animation_type_param == 1 do 
			(
				format "None\n" to:txt_file
			)
			if grooves[i].groove_data.groove_animation_type_param == 2 do 
			(
				format "Spin\n" to:txt_file
				format  "%\n" animation_modes[grooves[i].groove_data.groove_animation_mode_param] to:txt_file
				format  "%\n" grooves[i].groove_data.groove_animation_speed_param to:txt_file
				format "%,%,%\n" grooves[i].groove_data.groove_animation_centre_x_param grooves[i].groove_data.groove_animation_centre_z_param -grooves[i].groove_data.groove_animation_centre_y_param to:txt_file
				groove_axis = grooves[i].groove_data.groove_animation_axis_param
				if groove_axis == 1 do format  "x\n" to:txt_file
				if groove_axis == 2 do format  "y\n" to:txt_file
				if groove_axis == 3 do format  "z\n" to:txt_file
			)
			if grooves[i].groove_data.groove_animation_type_param == 3 do 
			(
				format "Rock\n" to:txt_file
				format  "%\n" animation_modes[grooves[i].groove_data.groove_animation_mode_param] to:txt_file
				format  "%\n" grooves[i].groove_data.groove_animation_speed_param to:txt_file
				format "%,%,%\n" grooves[i].groove_data.groove_animation_centre_x_param grooves[i].groove_data.groove_animation_centre_z_param -grooves[i].groove_data.groove_animation_centre_y_param to:txt_file
				groove_axis = grooves[i].groove_data.groove_animation_axis_param
				if groove_axis == 1 do format  "x\n" to:txt_file
				if groove_axis == 2 do format  "y\n" to:txt_file
				if groove_axis == 3 do format  "z\n" to:txt_file
				format  "%\n" grooves[i].groove_data.groove_animation_angle_param to:txt_file
			)
			if grooves[i].groove_data.groove_animation_type_param == 4 do 
			(
				format "Shear\n" to:txt_file
				format  "%\n" animation_modes[grooves[i].groove_data.groove_animation_mode_param] to:txt_file
				format  "%,%,%\n" grooves[i].groove_data.groove_animation_speed_param grooves[i].groove_data.groove_animation_speed_param grooves[i].groove_data.groove_animation_speed_param to:txt_file
				format "%,%,%\n" grooves[i].groove_data.groove_animation_centre_x_param grooves[i].groove_data.groove_animation_centre_z_param -grooves[i].groove_data.groove_animation_centre_y_param to:txt_file
				format "%,%,%\n" grooves[i].groove_data.groove_animation_extent_x_param grooves[i].groove_data.groove_animation_extent_z_param -grooves[i].groove_data.groove_animation_extent_y_param to:txt_file
			)
			if grooves[i].groove_data.groove_animation_type_param == 5 do 
			(
				format "Throb\n" to:txt_file
				format  "%\n" animation_modes[grooves[i].groove_data.groove_animation_mode_param] to:txt_file
				format  "%,%,%\n" grooves[i].groove_data.groove_animation_speed_param grooves[i].groove_data.groove_animation_speed_param grooves[i].groove_data.groove_animation_speed_param to:txt_file
				format "%,%,%\n" grooves[i].groove_data.groove_animation_centre_x_param grooves[i].groove_data.groove_animation_centre_z_param -grooves[i].groove_data.groove_animation_centre_y_param to:txt_file
				format "%,%,%\n" grooves[i].groove_data.groove_animation_extent_x_param grooves[i].groove_data.groove_animation_extent_z_param -grooves[i].groove_data.groove_animation_extent_y_param to:txt_file
			)
			if i != grooves.count do
			(
				format "\nNEXT GROOVE\n" to:txt_file
			)
		)
	)
	format "\nEND OF GROOVE\n\n" to:txt_file
	--OPPONENT PATHS
	format "START OF OPPONENT PATHS\n\n" to:txt_file
	
	if rootnode.track_general_attributes.opp_path_object != undefined do
	(
		opponentpath = rootnode.track_general_attributes.opp_path_object
		knotindex = 0
		opp_path_knots = #()
		opp_path_nodes = #()
		opp_path_segments = #()
		for i = 1 to numsplines opponentpath do
		(
			for j = 1 to numknots opponentpath i do
			(
				nodecoord = getKnotPoint opponentpath i j
				if (finditem opp_path_nodes nodecoord) == 0 then
				(
					knotindex = knotindex + 1
					append opp_path_nodes nodecoord
					append opp_path_knots knotindex
					--format "added knot %\n" knotindex to:txt_file
				)
				else
				(
					--knotindex = knotindex + 1
					append opp_path_knots (finditem opp_path_nodes nodecoord)
					--format "did not add knot %\n" knotindex to:txt_file
				)
			)
		)
		append opp_path_nodes ([0,0,500])
		append opp_path_knots (knotindex+1)
		
		--format "%\n\n" opp_path_knots.count to:txt_file
		--format "%\n\n" opp_path_nodes.count to:txt_file
		knotindex = 0
		for i = 1 to numsplines opponentpath do
		(	
			numknots_subspline = numknots opponentpath i
			for j = 1 to numknots_subspline do
			(
				knotindex = knotindex + 1
				currentknot = opp_path_knots[knotindex]
				if j == numknots_subspline then
				(
					if (isclosed opponentpath i) == true then
					(
						nextknot = 1
					)
					else
					(
						nextknot = undefined
					)
				)
				else
				(
					nextknot = opp_path_knots[knotindex+1]
				)
				if nextknot != undefined do
				(
					segment = [(currentknot-1),(nextknot-1)]
					append opp_path_segments segment
				)
			)
		)
		append opp_path_segments [0,(opp_path_nodes.count-1)]
		
		format "%	//number of path nodes\n\n" opp_path_nodes.count to:txt_file
		for i = 1 to opp_path_nodes.count do
		(
			format "%,%,%   	//node %\n" (opp_path_nodes[i].x) (opp_path_nodes[i].z) (-opp_path_nodes[i].y) (i-1) to:txt_file
		)
		format "\n%	//number of path segments\n\n" opp_path_segments.count to:txt_file
		for i = 1 to opp_path_segments.count do
		(
			format  "%,%,0,255,0,255,1.0,0	//path %\n" (opp_path_segments[i].x as integer) (opp_path_segments[i].y as integer) i to:txt_file
		)
		format "\n" to:txt_file
		format "0	//number of cop startpoints\n\n" to:txt_file
		format "END OF OPPONENT PATHS\n\n" to:txt_file
	)
	
	if rootnode.track_general_attributes.opp_path_object == undefined do
	(
		format "0	//number of path nodes\n\n" to:txt_file
		format "0	//number of path segments\n\n" to:txt_file
		format "0	//number of cop startpoints\n\n" to:txt_file
		format "END OF OPPONENT PATHS\n\n" to:txt_file
	)
	--DRONE PATHS
	
	format "START OF DRONE PATHS\n\n" to:txt_file
	format "2 // Version\n" to:txt_file
	if rootnode.track_general_attributes.drone_path_object != undefined then
	(
		dronepath = rootnode.track_general_attributes.drone_path_object
		knotindex = 0 --we start at zero
		drone_knots = #() --all the knots of the spline, referring to the drone_nodes indexes, including duplicate once.
		drone_nodes = #() --the coordinates of all the unique nodes.
		drone_nodes_next = # () --the arrays per node that contain the next possible nodes.
		for i = 1 to numsplines dronepath do
		(
			for j = 1 to numknots dronepath i do
			(
				nodecoord = getKnotPoint dronepath i j
				
				--first we determine whether the node is already stored.
				--if not, we add the new node and knot and link the previous knot to it. if we are at the end of the main loop, we link to knot 1
				if (finditem drone_nodes nodecoord) == 0 then
				(
					knotindex = knotindex + 1
					append drone_nodes nodecoord
					append drone_knots knotindex
				)
				--if the node already exists, we determine whether it is the end or beginning of a new section, connnecing to the main loop.
				else
				(
					--first we add the knot index based on the already existing node
					append drone_knots (finditem drone_nodes nodecoord)
					--locate the next node in the split up section from the already existing node in the main loop.
					--end of split up section. find the next node in the main loop which we link to. The previous knot will link to this found knot
				)
			)
		)
		
		
		knotindex = 0 --we start at zero
		--we create the array for the next nodes
		for i = 1 to drone_nodes.count do
		(
			append drone_nodes_next #()
		)
		--we fill the array for the next nodes with data
		for i = 1 to numsplines dronepath do
		(
			for j = 1 to numknots dronepath i do
			(
				knotindex = knotindex + 1
				if (knotindex) == (numknots dronepath i) and (isclosed dronepath i) == true then
				(
					drone_nodes_next[knotindex] = #(1)
				)
				else
				(
					currentknot = drone_knots[knotindex]
					nextknot = drone_knots[knotindex + 1]
					if nextknot != undefined do
					(
						append drone_nodes_next[currentknot] nextknot
					)
				)
			)
		)
		format "%	//number of drone path nodes\n\n" drone_nodes.count to:txt_file
		for i=1 to drone_nodes.count do 
		(
			format "%,%,%	//node %\n" drone_nodes[i].x drone_nodes[i].z -drone_nodes[i].y (i-1) to:txt_file
			format "None	//spawned drone\n" to:txt_file
			format "0	//unknown\n" to:txt_file
			format "%	//number of next nodes\n" drone_nodes_next[i].count to:txt_file
			nextdrones = drone_nodes_next[i]
			for j = 1 to nextdrones.count do
			(
				format "%, 0, 0, 0\n" (nextdrones[j]-1) to:txt_file
			)
			format "\n" to:txt_file
		)
	)
	else
	(
		format "0	//number of drone path nodes\n\n" to:txt_file
	)
	format "END OF DRONE PATHS\n\n" to:txt_file
	--DRIVING SURFACE TYPES
	mm_number = rootnode.track_general_attributes.mm_name_tab.count
	format "%	// number of Material Modifiers\n\n" mm_number  to:txt_file
	for i = 1 to mm_number do
	(
		format "// %\n" rootnode.track_general_attributes.mm_name_tab[i] to:txt_file
		format "%\n" rootnode.track_general_attributes.mm_car_wall_friction_tab[i] to:txt_file
		format "%\n" rootnode.track_general_attributes.mm_tyre_road_friction_tab[i] to:txt_file
		format "%\n" rootnode.track_general_attributes.mm_downforce_tab[i] to:txt_file
		format "%\n" rootnode.track_general_attributes.mm_bumpiness_tab[i] to:txt_file
		format "%\n" rootnode.track_general_attributes.mm_tyre_sound_index_tab[i] to:txt_file
		format "%\n" rootnode.track_general_attributes.mm_crash_sound_index_tab[i] to:txt_file
		format "%\n" rootnode.track_general_attributes.mm_scrape_sound_index_tab[i] to:txt_file
		format "%\n" rootnode.track_general_attributes.mm_sparkyness_tab[i] to:txt_file
		format "%\n" rootnode.track_general_attributes.mm_expansionroom_tab[i] to:txt_file
		skidmarks = #("SKIDMARK.MAT","DESKID.MAT","GIBSMEAR.MAT","MUD1.MAT","OILSMEAR.MAT","SNOWSKID.MAT")
		format "%\n\n" skidmarks[rootnode.track_general_attributes.mm_skidmark_tab[i]] to:txt_file
	)
	--NONCARS
	noncars = rootnode.track_general_attributes.noncar_list_param
	if noncars.count != 0 and noncars[1] != undefined then
	(
		format "%	//number of Noncars\n\n" noncars.count to:txt_file
		for i=1 to noncars.count do
		(
			noncar_string = "..\Races" + "\\" + (getfilenamefile txt_name) + "\\" + noncars[i] + ".txt"
			format "%\n" noncar_string to:txt_file
		)
		format "\n" to:txt_file
	)
	else
	(
		format "0	//number of Noncars\n\n" to:txt_file
	)
	--TYRE DUST TYPES
	format "%	//number of Tyre Dust Tables\n\n" rootnode.track_general_attributes.tyre_dust_nametab.count to:txt_file
	for i = 1 to rootnode.track_general_attributes.tyre_dust_nametab.count do
	(
		format "%,%,%	\\RGB values\n" rootnode.track_general_attributes.tyre_dust_colortab[i].r rootnode.track_general_attributes.tyre_dust_colortab[i].g rootnode.track_general_attributes.tyre_dust_colortab[i].b to:txt_file
		format "%,%,%	\\Strength values\n\n" rootnode.track_general_attributes.tyre_dust_quarterstrengthtab[i] rootnode.track_general_attributes.tyre_dust_halfstrengthtab[i] rootnode.track_general_attributes.tyre_dust_threequarterstrengthtab[i] to:txt_file
	)
	--NETWORK STARTPOINTS
	format "%	//number of Network Startpoints\n\n" mp_startingpoints.count to:txt_file
	for i =1 to mp_startingpoints.count do
	(
		format "%,%,%\n" (round mp_startingpoints[i].pos.x) (round mp_startingpoints[i].pos.z) (round -mp_startingpoints[i].pos.y) to:txt_file
		format "%\n\n" mp_startingpoints[i].rotation.z_rotation to:txt_file
	)
	--SPLASH PIX FILES
	format "1	// Number of splash files\n" to:txt_file
	format "CASPLASH.PIX	// Name of pixelmap files for splashes\n\n" to:txt_file
	--TRACK FILE NAME
	format "1	//number of Track files included\n" to:txt_file
	format "%	//Track File Name\n" (getfilenamefile txt_name + ".txt") to:txt_file
	--end of txt_file
	close txt_file
	--close txt_name
)