noncar_CA = attributes noncar_data
attribID:#(0xa7ac287, 0x5f123286)
(
	parameters noncar_parameters rollout:noncar_rollout
	(
		main type:#string
		keywords type:#string
	)
	rollout noncar_rollout "CARMATOOLS - noncar data"
	(
		label noncar_label_1 "This node is set as noncar"
	)
)

global keyw_ui = #()
global nonc_ui = #()
if nonc_tab == undefined do global nonc_tab = #(1,0,0,0,0,0,1,0,1,#(),#())
if nonc_keyw == undefined do global nonc_keyw = #(false,false,false,false,false,1,1,false,1,false,0,false,1,1,1,0.2,0,false,1,1,1,1,1,1,0.2,0,false,0,0,1,0,1,1,1,1,5000,false,false,false,1)
if noncar_object == undefined do global noncar_object = undefined
	
options.printAllElements = true

fn round f = 
(
	(((f * 1000000) as integer) as float / 1000000)
)
	
fn update_keyw nonc_keyw = 
(
	for i=1 to nonc_keyw.count do
	(
		try keyw_ui.enabled = false catch()
		if classof keyw_ui[i] == checkboxcontrol do keyw_ui[i].checked = nonc_keyw[i]
		if classof keyw_ui[i] == spinnercontrol do keyw_ui[i].range.z =nonc_keyw[i]
	)
	
	if noncar_object != undefined do
	(
		for i=1 to nonc_keyw.count do
		(
			try keyw_ui[i].checked = false catch()
		)
		for i in #(1,2,3,4,5,8,10,12,18,27) do
		(
			try keyw_ui[i].enabled = true catch()
			if nonc_keyw[i] == true do keyw_ui[i].checked = true
		)
		if nonc_keyw[5] == true do keyw_ui[6].enabled = keyw_ui[7].enabled = true
		if nonc_keyw[8] == true do keyw_ui[9].enabled = true
		if nonc_keyw[10] == true do keyw_ui[11].enabled = true
		if nonc_keyw[12] == true do keyw_ui[13].enabled = keyw_ui[14].enabled = keyw_ui[15].enabled = keyw_ui[16].enabled = keyw_ui[17].enabled = true
		if nonc_keyw[18] == true do keyw_ui[19].enabled=keyw_ui[20].enabled=keyw_ui[21].enabled=keyw_ui[22].enabled=keyw_ui[23].enabled=keyw_ui[24].enabled=keyw_ui[25].enabled=keyw_ui[26].enabled=true
		if nonc_keyw[27] == true do keyw_ui[28].enabled=keyw_ui[29].enabled=keyw_ui[30].enabled=keyw_ui[31].enabled=keyw_ui[32].enabled=keyw_ui[33].enabled=keyw_ui[34].enabled=keyw_ui[35].enabled=keyw_ui[36].enabled=keyw_ui[37].enabled=keyw_ui[38].enabled=keyw_ui[39].enabled=keyw_ui[40].enabled=true
	)
)

fn update_nonc nonc_tab shape_sel shape_typ = 
(
	try
	(
		for i=1 to 11 do
		(
			nonc_ui[i].enabled = false
			if classof nonc_ui[i] == spinnercontrol do nonc_ui[i].range.z = nonc_tab[i]
			if classof nonc_ui[i] == listboxcontrol do 
			(
				nonc_ui[i].items = nonc_tab[i]  
				nonc_ui[i].selection = shape_sel  
			)
			if classof nonc_ui[i] == ComboBoxControl do 
			(
				try nonc_ui[i].selection = nonc_tab[i][shape_typ] catch()
			)
		)
	)
	catch()
	if noncar_object != undefined do
	(
		if nonc_ui.count != 0 do
		(
			for i=1 to 11 do
			(
				nonc_ui[i].enabled = true
			)
		)
	)
)

rollout noncar_setup "Noncar Attributes"
( 
	group "Object selection"
	(
		pickbutton nonc_picker "Pick object" width:150  across:2 --autodisplay:true
		button nonc_reset "Reset" width:150
	)
	group "Properties"
	(
		spinner noncar_number "Noncar number:" type:#integer range:[0,99,1] scale: 1 fieldWidth:45 align:#right enabled:false
		label noncar_attached_center "Attachement point X,Y,Z:" align:#right across:4 offset:[65,0] enabled:false
		spinner noncar_attached_center_x "" type:#float range:[-999999,999999,0] scale: 0.1 fieldWidth:45  align:#right offset:[40,0] enabled:false
		spinner noncar_attached_center_y "" type:#float range:[-999999,999999,0] scale: 0.1 fieldWidth:45  align:#right offset:[20,0] enabled:false
		spinner noncar_attached_center_z "" type:#float range:[-999999,999999,0] scale: 0.1 fieldWidth:45  height:20  align:#right enabled:false
		label noncar_mass "Mass attached/detached:" align:#right across:3 offset:[100,0] enabled:false
		spinner noncar_mass_attached "" type:#float range:[-999999,999999,0] scale: 0.1  fieldWidth:45 align:#right offset:[47,0] enabled:false
		spinner noncar_mass_detached "" type:#float range:[-999999,999999,0] scale: 0.1  fieldWidth:45 align:#right offset:[0,0] height:20 enabled:false
		spinner noncar_bend_angle_value "Bend Angle:" type:#float range:[-999999,999999,1] scale: 0.1  fieldWidth:50 align:#right offset:[0,0] enabled:false --across:2
		spinner noncar_torque_value "Torque to push:" type:#float range:[0,90,0] scale: 1  fieldWidth:50 align:#right offset:[0,0] enabled:false
		spinner noncar_shrapnel_value "Shrapnel count:" type:#float range:[0,3,1] scale: 1  fieldWidth:50 align:#right offset:[0,0] enabled:false
		pickbutton noncar_bounding_object "Pick" across:2 width:150 offset:[0,17] enabled:false
	
		listbox noncar_bounding_shapes "Bounding shapes" height:7 enabled:false
		button noncar_bounding_object_delete "Remove" width:150 offset:[-85,-75] enabled:false
		dropdownlist noncar_bounding_shape "use shape as" items:#("None", "Box", "Sphere","Polyhedron","Wire frame") width:150 offset:[10,5] enabled:false
	)
	subrollout nonc_sub "" height:300 width:353 offset:[-9,0]
	button store_nonc_txt "Store in object" width:150 across:2  tooltip:"rightclick to remove properties"
	button export_nonc_txt "Export TXT" width:150 align:#left 
	
	on noncar_setup open do
	(
		global nonc_ui = #(noncar_number,noncar_attached_center_x,noncar_attached_center_y,noncar_attached_center_z,noncar_mass_attached,noncar_mass_detached,noncar_bend_angle_value,noncar_torque_value,noncar_shrapnel_value,noncar_bounding_shapes,noncar_bounding_shape)
		update_nonc nonc_tab 1 1
	)
	
	on nonc_picker picked obj do
	(
		if obj != undefined do
		(
			nonc_picker.text = obj.name
			select obj
			if custattributes.get obj noncar_CA != undefined then
			(
				global noncar_object = obj
				global nonc_tab = execute (obj.noncar_data.main)
				global nonc_keyw = execute (obj.noncar_data.keywords)
				update_nonc nonc_tab 1 1
				update_keyw nonc_keyw
			)
			else
			(
				global noncar_object = obj
			)
			noncar_bounding_object.enabled = true
			noncar_bounding_object_delete.enabled = true
			store_nonc_txt.enabled = true
			export_nonc_txt.enabled = true
			
			update_nonc nonc_tab 1 1
			update_keyw nonc_keyw
		)
	)
	on nonc_reset pressed do
	(
		--nonc_picker.autodisplay = false
		nonc_picker.text = "Pick object"
		global noncar_object = undefined
		global nonc_tab = #(1,0,0,0,0,0,1,0,1,#(),#())
		global nonc_keyw = #(false,false,false,false,false,1,1,false,1,false,0,false,1,1,1,0.2,0,false,1,1,1,1,1,1,0.2,0,false,0,0,1,0,1,1,1,1,5000,false,false,false,1)
		update_nonc nonc_tab 1 1
		update_keyw nonc_keyw
	)
	
	
	on noncar_bounding_object picked obj do
	(
		if obj != undefined do
		(
			append nonc_tab[10] obj.name
			--append noncar_bounding_shapes.items obj.name
			append nonc_tab[11] noncar_bounding_shape.selection
			noncar_bounding_shapes.items = noncar_bounding_shapes.items
			
		)
		if nonc_tab[11].count != 0 do noncar_bounding_shape.enabled = true
	)
	on noncar_bounding_object_delete pressed do
	(
		todeletenoncar = noncar_bounding_shapes.selection
		if todeletenoncar != 0 do
		(
			deleteitem noncar_bounding_shapes.items todeletenoncar
			deleteitem nonc_tab[11] todeletenoncar
			noncar_bounding_shapes.items = noncar_bounding_shapes.items
		)
		if nonc_tab[11].count == 0 do noncar_bounding_shape.enabled = false
	)
	on noncar_bounding_shape selected i do
	(
		if i != undefined do
		(
			nonc_tab[11][noncar_bounding_shapes.selection] = i
		)
	)
	on noncar_bounding_shapes selected i do
	(
		try noncar_bounding_shape.selection = nonc_tab[11][i] catch()
	)
	on noncar_number changed val do nonc_tab[1] = val
	on noncar_attached_center_x changed val do nonc_tab[2] = val
	on noncar_attached_center_y changed val do nonc_tab[3] = val
	on noncar_attached_center_z changed val do nonc_tab[4] = val
		
	on noncar_mass_attached changed val do nonc_tab[5] = val
	on noncar_mass_detached changed val do nonc_tab[6] = val
	on noncar_bend_angle_value changed val do nonc_tab[7] = val
	on noncar_torque_value changed val do nonc_tab[8] = val
	on noncar_shrapnel_value changed val do nonc_tab[9] = val
	
	on store_nonc_txt pressed do
	(
		if noncar_object != undefined do
		(
			custattributes.add noncar_object noncar_CA
			noncar_object.noncar_data.main = nonc_tab as string
			noncar_object.noncar_data.keywords = nonc_keyw as string
		)
	)
	
	on store_nonc_txt rightclick do
	(
		if custattributes.get noncar_object noncar_CA != undefined do
		(
			custattributes.delete noncar_object noncar_CA 
		)
	)
	
	on export_nonc_txt pressed do
	(
		txt_name = GetSaveFileName caption:"Choose an exportname" types:"Txt(*.txt)|*.txt"
		if txt_name != undefined then
		(
			txt_file = createfile txt_name
			
			format "101	//version number\n" to:txt_file
			format "%	//noncar number\n\n" nonc_tab[1] to:txt_file
			
			format "%,%,%	//centre point\n" noncar_object.center.x noncar_object.center.z -noncar_object.center.y to:txt_file
			format "%,%,%	//centre point when attached\n\n" nonc_tab[2] nonc_tab[3] nonc_tab[4] to:txt_file
			
			format "%	//number of bounding shapes\n" nonc_tab[10].count to:txt_file
			for i=1 to nonc_tab[10].count do
			(
				try bounding_shape = getnodebyname nonc_tab[10][i] catch(bounding_shape = undefined)
				if bounding_shape != undefined then
				(
					if nonc_tab[11][i] == 2 do
					(
						format "box\n%,%,%\n" (round bounding_shape.min.x) (round bounding_shape.min.z) (round -bounding_shape.min.y) to:txt_file
						format "%,%,%\n" (round bounding_shape.max.x) (round bounding_shape.max.z) (round -bounding_shape.max.y) to:txt_file
					)
					if nonc_tab[11][i] == 3 do
					(
						radius = (bounding_shape.max).x - (bounding_shape.center).x
						format "sphere\n"
						format "% \n" (round radius) to:txt_file
						format "%,%,% \n \n" (round (bounding_shape.center).x) (round (bounding_shape.center).z) (round -(bounding_shape.center).y) to:txt_file
					)
					if nonc_tab[11][i] == 4 do
					(
						format "polyhedron \n" to:txt_file
						polyhedron = snapshotasmesh bounding_shape
						pointcount = getnumverts polyhedron
						format "% \n \n" pointcount to:txt_file
						for j=1 to pointcount do
						(
							pointindex = getvert polyhedron j
							format "% ,% ,% \n"  (round pointindex.x) (round pointindex.z) (round -pointindex.y) to:txt_file
						)
						format "\n" to:txt_file
					)
					if nonc_tab[11][i] == 5 do
					(
						format "Wire frame \n \n" to:txt_file
						
						if (classof bounding_shape) == line then
						(
							numberofnodes = numknots bounding_object
							format "%				//number of points \n" numberofnodes to:txt_file
							for k = 1 to (numknots bounding_object) do
							(
								pointCoord = getKnotPoint object 1 k
								format "% ,% ,% \n" (round pointCoord.x) (round pointCoord.z) (round -pointCoord.y) to:txt_file
							)
							format "%				//number of segments \n" (numsegments bounding_object 1) to:txt_file
							knotnr = 0
							for k = 1 to (numsegments bounding_object 1) do
							(
								format "%,%  \n" knotnr (knotnr + 1) to:txt_file
								knotnr = (knotnr + 1)
							)
							format "\n" to:txt_file
						)
						else
						(
							wireshape = snapshotasmesh bounding_object
							numberofnodes = getnumverts wireshape
							format "%				//number of points \n" numberofnodes to:txt_file
							for k = 1 to (getnumverts wireshape) do
							(
								pointCoord = getvert wireshape 1
								format "% ,% ,% \n" (round pointCoord.x) (round pointCoord.z) (round -pointCoord.y) to:txt_file
							)
							format "%				//number of segments \n" (wireshape.edges.count) to:txt_file
							for k = 1 to (wireshape.edges.count) do
							(
								knots = meshop.getVertsUsingEdge wireshape k
								format "%,%  \n" (knots[1]-1)(knots[2]-1) to:txt_file
							)
							format "\n" to:txt_file
						)
					)
				)
				else
				(
					format "box	//shape not set properly\n-0.1,-0.1,-0.1\n" to:txt_file
					format "0.1,0.1,0.1\n\n" to:txt_file
				)
					
			)
			
			format "%,%	//mass unattached/attached\n" nonc_tab[5] nonc_tab[6] to:txt_file
			
			noncar_width = noncar_object.max.x - noncar_object.min.x
			noncar_length =noncar_object.max.y - noncar_object.min.y
			noncar_height =noncar_object.max.z - noncar_object.min.z
			format "%,%,%	//Total width, height and length\n" (round noncar_width) (round noncar_height) (round noncar_length) to:txt_file
			format "%	//bend angle\n" nonc_tab[7] to:txt_file
			format "%	//torque needed to move noncar\n" nonc_tab[8] to:txt_file
			format "1	//materials for shrapnel\nM14.MAT\n\n" to:txt_file
			
			if nonc_keyw[1] == true do format "INFINITE_I\n" to:txt_file
			if nonc_keyw[2] == true do format "DRIVABLE_ON\n" to:txt_file
			if nonc_keyw[3] == true do format "SPARKY\n" to:txt_file
			if nonc_keyw[4] == true do format "BLOCK_CAMERA\n" to:txt_file
			if nonc_keyw[5] == true do
			(
				format "TUMBLE\n" to:txt_file
				format "%	//tumble factor\n" nonc_keyw[6] to:txt_file
				format "%	//tumble threshhold\n" nonc_keyw[7] to:txt_file
			)
			if nonc_keyw[8] == true do
			(
				format "WORLD_FRICTION\n" to:txt_file
				format "%	//amount of friction\n" nonc_keyw[9] to:txt_file
			)
			if nonc_keyw[10] == true do
			(
				format "OBJECT_FRICTION\n" to:txt_file
				format "%	//amount of friction\n" nonc_keyw[11] to:txt_file
			)
			if nonc_keyw[12] == true do
			(
				format "WORLD_BALL_JOINT\n" to:txt_file
				format "%,%,%	//joint center point\n" nonc_keyw[13] nonc_keyw[15] -(nonc_keyw[14]) to:txt_file
				format "%	//friction\n" nonc_keyw[16] to:txt_file
				format "%	//num limits\n" nonc_keyw[17] to:txt_file
			)
			if nonc_keyw[18] == true do
			(
				format "WORLD_HINGE_JOINT\n" to:txt_file
				format "%,%,%	//joint point a\n" nonc_keyw[19] nonc_keyw[21] -(nonc_keyw[20]) to:txt_file
				format "%,%,%	//joint point b\n" nonc_keyw[22] nonc_keyw[24] -(nonc_keyw[23]) to:txt_file
				format "%	//friction\n" nonc_keyw[25] to:txt_file
				format "%	//num limits\n" nonc_keyw[26] to:txt_file
			)
			if nonc_keyw[27] == true do
			(
				format "WORLD_TRANSLATION_JOINT\n" to:txt_file
				format "0,0,0	//joint center point\n" to:txt_file
				format "%,%,%	//translation axis\n" nonc_keyw[28] nonc_keyw[30] -(nonc_keyw[29]) to:txt_file
				format "%	//translation distance\n" nonc_keyw[31] to:txt_file
				format "%	//forward acceleration\n" nonc_keyw[32] to:txt_file
				format "%	//reverse acceleration\n" nonc_keyw[33] to:txt_file
				format "%	//forward resistance\n" nonc_keyw[34] to:txt_file
				format "%	//reverse resistance\n" nonc_keyw[35] to:txt_file
				format "%	//pauze at end\n" nonc_keyw[36] to:txt_file
				if nonc_keyw[37] == true do format "IGNORE_WORLD_COLLISIONS\n" to:txt_file
				if nonc_keyw[38] == true do format "RISE_WHEN_DRIVEN_ON\n" to:txt_file
				if nonc_keyw[39] == true do format "RISE_WHEN_HIT\n" to:txt_file
				format "NUMBER_OF_PUSHES\n%	//number of pushes\n" nonc_keyw[40] to:txt_file
			)
			
			format "END" to:txt_file
			close txt_file
		)
	)

)

rollout nonc_keyw_data "Keyword data"
(
	group "Keyword Data"
	(
		checkbox noncar_infinite_i "Infinite I" align:#left
		checkbox noncar_drivable "Drivable on"  align:#left
		checkbox noncar_sparky "Sparky"  align:#left
		checkbox noncar_camera_block "Block Camera"  align:#left
		
		checkbox noncar_tumble "Tumble" align:#left across:3
		spinner noncar_tumble_factor "Factor:" type:#integer range:[1,2,1] scale: 1  fieldWidth:45 align:#right offset:[-20,0] enabled:false
		spinner noncar_tumble_threshhold "Threshhold:" type:#float range:[0,9999999,1] scale: 1  fieldWidth:45 align:#right offset:[0,0] enabled:false
		
		checkbox noncar_world_friction "World Friction" checked:false align:#left across:2
		spinner noncar_world_friction_amount "Amount:" type:#float range:[0,9999999,1] scale: 1  fieldWidth:45 align:#right offset:[0,0] enabled:false
		
		checkbox noncar_object_friction "Object Friction" checked:false align:#left across:2
		spinner noncar_object_friction_amount "Amount:" type:#float range:[0,9999999,2] scale: 1  fieldWidth:45 align:#right offset:[0,0] enabled:false
		
		checkbox noncar_ball_joint "World Ball Joint" checked:false align:#left
		spinner noncar_ball_joint_x "Joint centre point:" type:#float range:[0,999999,1] scale: 0.1 fieldWidth:45 align:#right across:3 offset:[70,0] enabled:false
		spinner noncar_ball_joint_y "" type:#float range:[0,999999,1] scale: 0.1 fieldWidth:45 align:#right offset:[35,0] enabled:false
		spinner noncar_ball_joint_z "" type:#float range:[0,999999,1] scale: 0.1 fieldWidth:45 align:#right height:20  enabled:false
		spinner noncar_ball_joint_friction "Amount:" type:#float range:[0,9999999,0.2] scale: 0.1  fieldWidth:45 align:#right offset:[21,0] across:2 enabled:false
		spinner noncar_ball_joint_limits "Nr. limits:" type:#integer range:[0,99999999,0] fieldWidth:45 align:#right offset:[00,0] enabled:false
				
		checkbox noncar_hinge_joint "World Hinge Joint" checked:false align:#left
		spinner noncar_hinge_a_x "Joint point A:" type:#float range:[0,999999,1] scale: 0.1 fieldWidth:45 align:#right across:3 offset:[70,0] enabled:false
		spinner noncar_hinge_a_y "" type:#float range:[0,999999,1] scale: 0.1 fieldWidth:45 align:#right offset:[35,0] enabled:false
		spinner noncar_hinge_a_z "" type:#float range:[0,999999,1] scale: 0.1 fieldWidth:45 align:#right height:20  enabled:false
		spinner noncar_hinge_b_x "Joint point B:" type:#float range:[0,999999,1] scale: 0.1 fieldWidth:45 align:#right across:3 offset:[70,0] enabled:false
		spinner noncar_hinge_b_y "" type:#float range:[0,999999,1] scale: 0.1 fieldWidth:45 align:#right offset:[35,0] enabled:false
		spinner noncar_hinge_b_z "" type:#float range:[0,999999,1] scale: 0.1 fieldWidth:45 align:#right height:20  enabled:false
		spinner noncar_hinge_joint_friction "Amount:" type:#float range:[0,9999999,0.2] scale: 0.1  fieldWidth:51 align:#right offset:[0,0]  enabled:false
		spinner noncar_hinge_joint_limits "Nr. limits:" type:#integer range:[0,99999999,0] fieldWidth:51 align:#right offset:[0,0]  enabled:false
		
		checkbox noncar_translation_joint "World Translation Joint" checked:false align:#left
		spinner noncar_translation_joint_amount_x "Translation Axis X,Y,Z:" type:#integer range:[-1,1,0] scale: 1 fieldWidth:45 align:#right across:3 offset:[70,0] enabled:false
		spinner noncar_translation_joint_amount_y "" type:#integer range:[-1,1,0] scale: 1 fieldWidth:45 align:#right offset:[35,0] enabled:false
		spinner noncar_translation_joint_amount_z "" type:#integer range:[-1,1,1] scale: 1 fieldWidth:45 align:#right height:20  enabled:false
		spinner noncar_translation_joint_distance "Distance:" type:#float range:[0,9999999,0] scale: 0.1  fieldWidth:45 align:#right offset:[0,0]  enabled:false
		spinner noncar_translation_joint_forward_acceleration "Forward/Reverse Acceleration:" type:#float range:[0,9999999,1] scale: 0.1  fieldWidth:45 align:#right offset:[84,0] across:2 enabled:false
		spinner noncar_translation_joint_reverse_acceleration "" type:#float range:[0,9999999,1] scale: 0.1  fieldWidth:45 align:#right offset:[0,0]  enabled:false
		spinner noncar_translation_joint_forward_resistance "Forward/Reverse Resistance:" type:#float range:[0,9999999,1] scale: 0.1  fieldWidth:45 align:#right offset:[84,0] across:2 enabled:false
		spinner noncar_translation_joint_reverse_resistance "" type:#float range:[0,9999999,1] scale: 1  fieldWidth:45 align:#right offset:[0,0]  enabled:false
		spinner noncar_translation_joint_pauze "Pauze at end:" type:#float range:[0,9999999,5000] scale: 1  fieldWidth:45 align:#right offset:[0,0]  enabled:false
		checkbox noncar_translation_joint_ignorewc "Ignore world collision" checked:false align:#left  enabled:false
		checkbox noncar_translation_joint_driven "Rise when driven" checked:false align:#left   enabled:false
		checkbox noncar_translation_joint_hit "Rise when hit" checked:false align:#left  enabled:false
		spinner noncar_translation_joint_pushes "Nr. pushes:" type:#Integer range:[0,9999999,1] scale: 1  fieldWidth:51 align:#right offset:[0,0]  enabled:false
	)
	on nonc_keyw_data open do
	(
		global keyw_ui = #(noncar_infinite_i,noncar_drivable,noncar_sparky,noncar_camera_block,noncar_tumble,noncar_tumble_factor,noncar_tumble_threshhold,noncar_world_friction,noncar_world_friction_amount,noncar_object_friction,noncar_object_friction_amount,noncar_ball_joint,noncar_ball_joint_x,noncar_ball_joint_y,noncar_ball_joint_z,noncar_ball_joint_friction,noncar_ball_joint_limits,noncar_hinge_joint,noncar_hinge_a_x,noncar_hinge_a_y,noncar_hinge_a_z,noncar_hinge_b_x,noncar_hinge_b_y,noncar_hinge_b_z,noncar_hinge_joint_friction,noncar_hinge_joint_limits,noncar_translation_joint,noncar_translation_joint_amount_x,noncar_translation_joint_amount_y,noncar_translation_joint_amount_z,noncar_translation_joint_distance,noncar_translation_joint_forward_acceleration,noncar_translation_joint_reverse_acceleration,noncar_translation_joint_forward_resistance,noncar_translation_joint_reverse_resistance,noncar_translation_joint_pauze,noncar_translation_joint_ignorewc,noncar_translation_joint_driven,noncar_translation_joint_hit,noncar_translation_joint_pushes)
		update_keyw nonc_keyw
		
	)
	on noncar_infinite_i changed val do nonc_keyw[1] = val
	on noncar_drivable changed val do nonc_keyw[2] = val
	on noncar_sparky changed val do nonc_keyw[3] = val
	on noncar_camera_block changed val do nonc_keyw[4] = val

	on noncar_tumble_factor changed val do nonc_keyw[6] = val
	on noncar_tumble_threshhold changed val do nonc_keyw[7] = val

	on noncar_world_friction_amount changed val do nonc_keyw[9] = val

	on noncar_object_friction_amount changed val do nonc_keyw[11] = val

	on noncar_ball_joint_x changed val do nonc_keyw[13] = val
	on noncar_ball_joint_y changed val do nonc_keyw[14] = val
	on noncar_ball_joint_z changed val do nonc_keyw[15] = val
	on noncar_ball_joint_friction changed val do nonc_keyw[16] = val
	on noncar_ball_joint_limits changed val do nonc_keyw[17] = val

	on noncar_hinge_a_x changed val do nonc_keyw[19] = val
	on noncar_hinge_a_y changed val do nonc_keyw[20] = val
	on noncar_hinge_a_z changed val do nonc_keyw[21] = val
	on noncar_hinge_b_x changed val do nonc_keyw[22] = val
	on noncar_hinge_b_y changed val do nonc_keyw[23] = val
	on noncar_hinge_b_z changed val do nonc_keyw[24] = val
	on noncar_hinge_joint_friction changed val do nonc_keyw[25] = val
	on noncar_hinge_joint_limits changed val do nonc_keyw[26] = val

	on noncar_translation_joint_amount_x changed val do nonc_keyw[28] = val
	on noncar_translation_joint_amount_y changed val do nonc_keyw[29] = val
	on noncar_translation_joint_amount_z changed val do nonc_keyw[30] = val
	on noncar_translation_joint_distance changed val do nonc_keyw[31] = val
	on noncar_translation_joint_forward_acceleration changed val do nonc_keyw[32] = val
	on noncar_translation_joint_reverse_acceleration changed val do nonc_keyw[33] = val
	on noncar_translation_joint_forward_resistance changed val do nonc_keyw[34] = val
	on noncar_translation_joint_reverse_resistance changed val do nonc_keyw[35] = val
	on noncar_translation_joint_pauze changed val do nonc_keyw[36] = val
	on noncar_translation_joint_ignorewc changed val do nonc_keyw[37] = val
	on noncar_translation_joint_driven changed val do nonc_keyw[38] = val
	on noncar_translation_joint_hit changed val do nonc_keyw[39] = val
	on noncar_translation_joint_pushes changed val do nonc_keyw[40] = val

	on noncar_tumble changed i do
	(
		nonc_keyw[5] = i
		if i == true then
		(
			noncar_tumble_factor.enabled = true
			noncar_tumble_threshhold.enabled = true
		)
		else 
		(
			noncar_tumble_factor.enabled = false 
			noncar_tumble_threshhold.enabled = false
		)
	)
	on noncar_world_friction changed i do
	(
		nonc_keyw[8] = i
		if i == true then
			noncar_world_friction_amount.enabled = true
		else
			noncar_world_friction_amount.enabled = false
	)
	on noncar_object_friction changed i do
	(
		nonc_keyw[10] = i
		if i == true then
			noncar_object_friction_amount.enabled = true
		else
			noncar_object_friction_amount.enabled = false
	)
	on noncar_ball_joint changed i do
	(
		nonc_keyw[12] = i
		if i == true then
		(
			noncar_ball_joint_x.enabled = true
			noncar_ball_joint_y.enabled = true
			noncar_ball_joint_z.enabled = true
			noncar_ball_joint_friction.enabled = true
			noncar_ball_joint_limits.enabled = true
		)
		else
		(
			noncar_ball_joint_x.enabled = false
			noncar_ball_joint_y.enabled = false
			noncar_ball_joint_z.enabled = false
			noncar_ball_joint_friction.enabled = false
			noncar_ball_joint_limits.enabled = false
		)
	)
	on noncar_hinge_joint changed i do
	(
		nonc_keyw[18] = i
		if i == true then
		(
			noncar_hinge_a_x.enabled = true
			noncar_hinge_a_y.enabled = true
			noncar_hinge_a_z.enabled = true
			noncar_hinge_b_x.enabled = true
			noncar_hinge_b_y.enabled = true
			noncar_hinge_b_z.enabled = true
			noncar_hinge_joint_friction.enabled = true
			noncar_hinge_joint_limits.enabled = true
		)
		else
		(
			noncar_hinge_a_x.enabled = false
			noncar_hinge_a_y.enabled = false
			noncar_hinge_a_z.enabled = false
			noncar_hinge_b_x.enabled = false
			noncar_hinge_b_y.enabled = false
			noncar_hinge_b_z.enabled = false
			noncar_hinge_joint_friction.enabled = false
			noncar_hinge_joint_limits.enabled = false
		)
	)
	on noncar_translation_joint changed i do
	(
		nonc_keyw[27] = i
		if i == true then
		(
			noncar_translation_joint_amount_x.enabled = true
			noncar_translation_joint_amount_y.enabled = true
			noncar_translation_joint_amount_z.enabled = true
			noncar_translation_joint_distance.enabled = true
			noncar_translation_joint_forward_acceleration.enabled = true
			noncar_translation_joint_reverse_acceleration.enabled = true
			noncar_translation_joint_forward_resistance.enabled = true
			noncar_translation_joint_reverse_resistance.enabled = true
			noncar_translation_joint_pauze.enabled = true
			noncar_translation_joint_ignorewc.enabled = true
			noncar_translation_joint_driven.enabled = true
			noncar_translation_joint_hit.enabled = true
			noncar_translation_joint_pushes.enabled = true
		)
		else
		(
			noncar_translation_joint_amount_x.enabled = false
			noncar_translation_joint_amount_y.enabled = false
			noncar_translation_joint_amount_z.enabled = false
			noncar_translation_joint_distance.enabled = false
			noncar_translation_joint_forward_acceleration.enabled = false
			noncar_translation_joint_reverse_acceleration.enabled = false
			noncar_translation_joint_forward_resistance.enabled = false
			noncar_translation_joint_reverse_resistance.enabled = false
			noncar_translation_joint_pauze.enabled = false
			noncar_translation_joint_ignorewc.enabled = false
			noncar_translation_joint_driven.enabled = false
			noncar_translation_joint_hit.enabled = false
			noncar_translation_joint_pushes.enabled = false
		)
	)
)
	
createdialog noncar_setup 360 670
addsubrollout noncar_setup.nonc_sub nonc_keyw_data rolledup:false