wam_data_CA = attributes wam_data
attribID:#(0x6478c3cd, 0x76c6fa01)
(
	parameters Wam rollout:wam_params
	(
		softness ui:softness type:#integer default:1
		crush_type type:#integer default:1
		flap_point1_param type:#integer default:0
		flap_point2_param type:#integer default:0
		flap_point3_param type:#integer default:0
		flap_openable ui:flap_openable type:#integer default:1
		flap_ease ui:flap_ease type:#integer default:1
		flap_box ui:flap_box type:#integer default:1
		detach_ease ui:detach_ease type:#integer default:1
		detach_type ui:detach_type type:#integer default:1
		detach_box ui:detach_box type:#integer default:1
		smash_data type:#integer default:0
	)
	rollout wam_params "Wam Parameters"
	(
		group "Softness:"
		(
			dropdownlist softness "" items:#("soft", "normal", "hard", "uncrushable")
		)
		group "Crush type:"
		(
			checkbox crush_boring "Boring" checked:(crush_type == 1)
			checkbox crush_flap "Flap"
			edittext flap_point1 "hinge point 1" width:100 align:#right
			on flap_point1 entered txt do flap_point1_param = txt as integer
			edittext flap_point2 "hinge point 2" width:100 align:#right
			on flap_point2 entered txt do flap_point2_param = txt as integer
			edittext flap_point3 "hinge point 3" width:100 align:#right
			on flap_point3 entered txt do flap_point3_param = txt as integer
			checkbox flap_openable "Open as door" align:#right width:100
			dropdownlist flap_ease "Ease of flapping:" items:#("very_easy","easy","normal","difficult","very_difficult") align:#right width:100
			dropdownlist flap_box "Bounding of flap:" items:#("box","sphere") align:#right width:100
			checkbox crush_detach "Detach"
			dropdownlist detach_ease "Ease of detach:" items:#("very_easy","easy","normal","difficult","very_difficult") align:#right width:100
			dropdownlist detach_type "Type of detach:" items:#("normal","stubborn","fully_detach") align:#right width:100
			dropdownlist detach_box "Bounding of detach:" items:#("box","sphere") align:#right width:100
			on crush_boring changed thestate do
			(
				if thestate == true do
				(
					crush_type = 1
					crush_flap.checked = false
					flap_point1.enabled = false
					flap_point2.enabled = false
					flap_point3.enabled = false
					flap_openable.enabled = false
					flap_ease.enabled = false
					flap_box.enabled = false
					crush_detach.checked = false
					detach_ease.enabled = false
					detach_type.enabled = false
					detach_box.enabled = false
				)
			)
			on crush_flap changed thestate do
			(
				if thestate == true do
				(
					crush_type = 2
					crush_boring.checked = false
					flap_point1.enabled = true
					flap_point2.enabled = true
					flap_point3.enabled = true
					flap_openable.enabled = true
					flap_ease.enabled = true
					flap_box.enabled = true
					crush_detach.checked = false
					detach_ease.enabled = false
					detach_type.enabled = false
					detach_box.enabled = false
				)
			)
			on crush_detach changed thestate do
			(
				if thestate == true do
				(
					crush_type = 3
					crush_boring.checked = false
					crush_flap.checked = false
					flap_point1.enabled = false
					flap_point2.enabled = false
					flap_point3.enabled = false
					flap_openable.enabled = false
					flap_ease.enabled = false
					flap_box.enabled = false
					crush_detach.checked = true
					detach_ease.enabled = true
					detach_type.enabled = true
					detach_box.enabled = true
				)
			)
		)
		
		group "Smash data entries:"
		(
			checkbox smash_use "Use smash materials"
			on smash_use changed thestate do
			(
				if thestate == true do
				(
					smash_data = 1
				)
				if thestate == false do
				(
					smash_data = 0
				)
			)
		)
		on wam_params open do
		(
			flap_point1.text = flap_point1_param as string
			flap_point2.text = flap_point2_param as string
			flap_point3.text = flap_point3_param as string
			if smash_data == 1 do
			(
				smash_use.checked = true
			)
			if crush_type == 1 do
			(
				crush_boring.checked = true
				crush_flap.checked = false
				flap_point1.enabled = false
				flap_point2.enabled = false
				flap_point3.enabled = false
				flap_openable.enabled = false
				flap_ease.enabled = false
				flap_box.enabled = false
				crush_detach.checked = false
				detach_ease.enabled = false
				detach_type.enabled = false
				detach_box.enabled = false
			)
			if crush_type == 2 do
			(
				crush_flap.checked = true
				crush_boring.checked = false
				flap_point1.enabled = true
				flap_point2.enabled = true
				flap_point3.enabled = true
				flap_openable.enabled = true
				flap_ease.enabled = true
				flap_box.enabled = true
				crush_detach.checked = false
				detach_ease.enabled = false
				detach_type.enabled = false
				detach_box.enabled = false
			)
			if crush_type == 3 do
			(
				crush_boring.checked = false
				crush_flap.checked = false
				flap_point1.enabled = false
				flap_point2.enabled = false
				flap_point3.enabled = false
				flap_openable.enabled = false
				flap_ease.enabled = false
				flap_box.enabled = false
				crush_detach.checked = true
				detach_ease.enabled = true
				detach_type.enabled = true
				detach_box.enabled = true
			)
		)
	)
)